//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2010)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org

#include <iostream>
#include <fstream>
#include <string>
#include "get_grid.h"

using namespace std;

void getGRID::setFile(char file_load[])
{
       infile=file_load;

}

void getGRID::getPointsFromFile()
{
     ifstream fin(infile);
     getline(fin, file_content,'\t');
     fin.close();
}

void getGRID::analyze_file_content()
{
     long counter1=0, counter2=0, counter_token=0;
     char *token;
     char *temp_total_chars;
     long numCols=0, numRows=0;
//     double xDist=0, yDist=0;   
     char seps[]=" ,\t\\n";
     
     const char *total_chars=file_content.c_str();
     temp_total_chars = (char*)total_chars;

    //read "ncols"
     token = strtok((char*)temp_total_chars," ");
     counter_token=strlen(token)+9;
     temp_total_chars=temp_total_chars+counter_token;

    //read number of columns
     token = strtok((char*)temp_total_chars,"\n");
     numCols=atoi(token);
     counter_token=strlen(token)+1;
     temp_total_chars=temp_total_chars+counter_token;
    
    //read "nrows"
     token = strtok((char*)temp_total_chars," ");
     counter_token=strlen(token)+9;
     temp_total_chars=temp_total_chars+counter_token;
     
     //read number of rows
     token = strtok((char*)temp_total_chars,"\n");
     numRows=atoi(token);
     counter_token=strlen(token)+1;
     temp_total_chars=temp_total_chars+counter_token;
     
     //read "xllcorner"
     token = strtok((char*)temp_total_chars," ");
     counter_token=strlen(token)+5;
     temp_total_chars=temp_total_chars+counter_token;
     
     //read x-value of lower left corner
     token = strtok((char*)temp_total_chars,"\n");
     xmin=atof(token);
     counter_token=strlen(token)+1;
     temp_total_chars=temp_total_chars+counter_token;
     
     //read "yllcorner"
     token = strtok((char*)temp_total_chars," ");
     counter_token=strlen(token)+5;
     temp_total_chars=temp_total_chars+counter_token;
     
     //read y-value of lower left corner
     token = strtok((char*)temp_total_chars,"\n");
     ymin=atof(token);
     counter_token=strlen(token)+1;
     temp_total_chars=temp_total_chars+counter_token; 
     
     //read "cellsize"
     token = strtok((char*)temp_total_chars," ");
     counter_token=strlen(token)+5;
     temp_total_chars=temp_total_chars+counter_token;
     
     //read size of quadratic cell
     token = strtok((char*)temp_total_chars,"\n");
     xDist=atof(token);
     counter_token=strlen(token)+1;
     temp_total_chars=temp_total_chars+counter_token; 
     
//     yDist=xDist;
     
     //read "NODATA_value -9999"
     token = strtok((char*)temp_total_chars,"\n");
//     xDist=atof(token);
     counter_token=strlen(token)+1;
     temp_total_chars=temp_total_chars+counter_token;
          
     num_points = numCols * numRows;
//     num_faces = ((numCols-1)*2)*(numRows-1);
     num_cols=numCols;
     num_rows=numRows;
     
//     x=new double[num_points];
//     y=new double[num_points];
     z=new double[num_points];
     
//     xDist=(xmax-xmin)/(numCols-1);
//     yDist=(ymax-ymin)/(numRows-1);
     
     for(counter1=0;counter1<numRows;counter1++)
     {
            for(counter2=0;counter2<numCols; counter2++)
            {
//                x[counter1*numCols+counter2]=xmin+counter2*xDist;
//                y[counter1*numCols+counter2]=ymin+counter1*yDist;
                token = strtok((char*)temp_total_chars,seps);
                z[counter1*numCols+counter2]=atof(token);
                counter_token=strlen(token)+1;
                temp_total_chars=temp_total_chars+counter_token;
            }
     }
    

}

void getGRID::getPoints(double z_value[])
{
    long counterPoints;
    
    for (counterPoints=0; counterPoints<num_points;counterPoints++)
    {
//        x_coord[counterPoints]=x[counterPoints];
//        y_coord[counterPoints]=y[counterPoints];
        z_value[counterPoints]=z[counterPoints];
    }
}

void getGRID::getBoundaries(double bounds[])
{
    bounds[0]=xmin;
    bounds[1]=xmax;
    bounds[2]=ymin;
    bounds[3]=ymax;
    bounds[4]=zmin;
    bounds[5]=zmax;
}

