//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#ifndef __TIMEPERIODSETTINGS_H__
#define __TIMEPERIODSETTINGS_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/checkbox.h>
#include <wx/button.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
////Header Include End

////Dialog Style Start
#undef TimePeriodSettings_STYLE
#define TimePeriodSettings_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class TimePeriodSettings : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		TimePeriodSettings(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Stress period settings"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = TimePeriodSettings_STYLE);
		virtual ~TimePeriodSettings();
		void WxButtonSetStressPeriodClick(wxCommandEvent& event);
		wxString getPeriodLength();
		void WxCheckBoxSteadyStateClick(wxCommandEvent& event);
		wxString getTimeStepLength();
		void WxCheckBoxTransientClick(wxCommandEvent& event);
		wxString getMode()const {return strTimeMode;}
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxCheckBox *WxCheckBoxTransient;
		wxCheckBox *WxCheckBoxSteadyState;
		wxButton *WxButtonSetStressPeriod;
		wxTextCtrl *WxEditTimeStepLength;
		wxTextCtrl *WxEditLengthStressPeriod;
		wxStaticText *WxStaticTextTimeStepLength;
		wxStaticText *WxStaticTextStressPeriodLength;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXCHECKBOXTRANSIENT = 1007,
			ID_WXCHECKBOXSTEADYSTATE = 1006,
			ID_WXBUTTONSETSTRESSPERIOD = 1005,
			ID_WXEDITTIMESTEPLENGTH = 1004,
			ID_WXEDITLENGTHSTRESSPERIOD = 1003,
			ID_WXSTATICTEXTTIMESTEPLENGTH = 1002,
			ID_WXSTATICTEXTSTRESSPERIODLENGTH = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		wxString strNumberPeriods;
		wxString strTimeStepLength;
		int intModeSet;
		wxString strTimeMode;
		
};

#endif
