//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org

#include <iostream>
#include <fstream>
#include <string>
#include <wx/wx.h>
#include "transfer2gis.h"

using namespace std;


void transferResults::setFile(char file_load[], char transferPath[])
{
    infile=file_load;
    path=transferPath;
}


void transferResults::getPointsFromFile()
{
    ifstream fin(infile);
    getline(fin, file_content,'\t');
    fin.close();
}


void transferResults::analyze_file_content()
{
    char *temp_total_chars; 
    char *token;
    long counter_token, numberTokens;
    wxString wxstrTempStr;
    
    long lngNumDataMFRes;
    lngNumDataMFRes=(((long)lngNCols/10)+1)*lngNRows;
    
    const char *total_chars=file_content.c_str();
    temp_total_chars = (char*)total_chars;
    numberTokens=strlen(temp_total_chars);
    
    z=new double[lngNumDataMFRes];
    
    for(long intCounterPer=0;intCounterPer<lngPeriods;intCounterPer++)
    {
        for (long intCounterLay=0;intCounterLay<lngLayers;intCounterLay++)
        {
            wxstrTempStr="";
            for (long intCounterRowsPerLayer=0;intCounterRowsPerLayer<lngNumDataMFRes;intCounterRowsPerLayer++)
            {
//                wxstrTempStr="";
                token = strtok((char*)temp_total_chars,"\n");
//                z[intCounterCellsPerLayer]=atof(token);
                counter_token=strlen(token);
                temp_total_chars=temp_total_chars+counter_token+1;
                wxstrTempStr<<token<<"\n";
//                wxMessageBox(wxstrTempStr);
            }
            wxMessageBox("Write");
            writeGridFile(intCounterPer, intCounterLay, wxstrTempStr);
        }
    }
    
}


void transferResults::setGridParams(long lngNumCols, long lngNumRows, long lngNumPer, long lngNumLay, double dblXLL, double dblYLL, double dblCellS)
{
    lngNCols=lngNumCols;
    lngNRows=lngNumRows;
    lngPeriods=lngNumPer;
    lngLayers=lngNumLay;
    dblXMin=dblXLL;
    dblYMin=dblYLL;
    dblCellSize=dblCellS;
}
void transferResults::writeGridFile(long lngPerNum, long lngLayNum, wxString wxstrValues)
{
    wxString wxstrFileString;
    wxString wxstrDataString;
    long lngCounter=0;
    
    wxstrDataString="";
    wxstrDataString<<"ncols         "<<lngNCols<<"\n";
    wxstrDataString<<"nrows         "<<lngNRows<<"\n";
    wxstrDataString<<"xllcorner     "<<dblXMin<<"\n";
    wxstrDataString<<"yllcorner     "<<dblYMin<<"\n";
    wxstrDataString<<"cellsize      "<<dblCellSize<<"\n";
    wxstrDataString<<"NODATA_value  -9999\n";
    
    wxstrDataString<<wxstrValues;
    
    wxstrFileString="";
    wxstrFileString<<path<<"\\mfP"<<lngPerNum<<"L"<<lngLayNum<<".asc";
    wxMessageBox(wxstrFileString);
    ofstream outFile(wxstrFileString);//"D:\\grass_modflow\\grass_modflow\\testdata\\aaa.wel");
    outFile<<wxstrDataString;
    outFile.close();
}

