//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#include "gui2Frm.h"
#include "timesets.h"
#include "get_grid_wx.h"
#include "parameters.h"
#include "get_well_data.h"
#include "transfer2gis.h"
#include "get_proj.h"
#include <iostream>
#include <fstream>
#include <vector>
#include <cctype>

using namespace std;

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// gui2Frm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(gui2Frm,wxFrame)
	////Manual Code Start
	////Manual Code End

	EVT_CLOSE(gui2Frm::OnClose)
	EVT_MENU(ID_MNU_NEWPROJECT_1119, gui2Frm::Mnunewproject1119Click)
	EVT_MENU(ID_MNU_OPENPROJECT_1030, gui2Frm::Mnuopenproject1030Click)
	EVT_MENU(ID_MNU_SAVEPROJECT_1031, gui2Frm::Mnusaveproject1031Click)
	EVT_MENU(ID_MNU_SAVEPROJECTAS_1038, gui2Frm::Mnusaveprojectas1038Click)
	EVT_MENU(ID_MNU_EXIT_1032, gui2Frm::Mnuexit1032Click)
	EVT_MENU(ID_MNU_HELPTOPICS_1034, gui2Frm::Mnuhelptopics1034Click)
	EVT_MENU(ID_MNU_MANUAL_1035, gui2Frm::Mnumanual1035Click)
	EVT_MENU(ID_MNU_ABOUT_1036, gui2Frm::Mnuabout1036Click)
	EVT_BUTTON(ID_WXBUTTONTRANSFERTOGIS,gui2Frm::WxButtonTransferToGISClick)
	EVT_BUTTON(ID_WXBUTTONSAVERUNMODFLOW,gui2Frm::WxButtonSaveRunModflowClick)
	EVT_BUTTON(ID_WXBUTTONADDSAVELAYER,gui2Frm::WxButtonAddSaveLayerClick)
	EVT_BUTTON(ID_WXBUTTONADDSAVEPERIOD,gui2Frm::WxButtonAddSavePeriodClick)
	EVT_BUTTON(ID_WXBUTTONSAVEOUTPUTCONTROL,gui2Frm::WxButtonSaveOutputControlClick)
	EVT_CHECKBOX(ID_WXCHECKBOXSAVERESALLLAYERS,gui2Frm::WxCheckBoxSaveResAllLayersClick)
	EVT_LISTBOX(ID_WXLISTBOXSAVERESLAYERS,gui2Frm::WxListBoxSaveResLayersSelected)
	EVT_CHECKBOX(ID_WXCHECKBOXSAVERESALLSTRESSPERIODS,gui2Frm::WxCheckBoxSaveResAllStressPeriodsClick)
	EVT_LISTBOX(ID_WXLISTBOXSAVERESSTRESSPERIODS,gui2Frm::WxListBoxSaveResStressPeriodsSelected)
	EVT_BUTTON(ID_WXBUTTONRECHWELLSSAVEMODFLOW,gui2Frm::WxButtonRechWellsSaveModflowClick)
	EVT_BUTTON(ID_WXBUTTONWELLSDELETE,gui2Frm::WxButtonWellsDeleteClick)
	EVT_BUTTON(ID_WXBUTTONWELLSINSERT,gui2Frm::WxButtonWellsInsertClick)
	EVT_BUTTON(ID_WXBUTTONRECHCLEAR,gui2Frm::WxButtonRechClearClick)
	EVT_BUTTON(ID_WXBUTTONRECHINSERT,gui2Frm::WxButtonRechInsertClick)
	EVT_BUTTON(ID_WXBUTTONSAVEBOUNDARYCONDINITIALHEADS,gui2Frm::WxButtonSaveBoundaryCondInitialHeadsClick)
	EVT_BUTTON(ID_WXBUTTONCLEARINITIALHEADS,gui2Frm::WxButtonClearInitialHeadsClick)
	EVT_BUTTON(ID_WXBUTTONINSERTINITIALHEADS,gui2Frm::WxButtonInsertInitialHeadsClick)
	EVT_BUTTON(ID_WXBUTTONCLEARBOUNDARYCOND,gui2Frm::WxButtonClearBoundaryCondClick)
	EVT_BUTTON(ID_WXBUTTONINSERTBOUNDARYCOND,gui2Frm::WxButtonInsertBoundaryCondClick)
	EVT_RADIOBUTTON(ID_WXRADIOBUTTONVERTVALUES,gui2Frm::WxRadioButtonVertValuesClick)
	EVT_RADIOBUTTON(ID_WXRADIOBUTTONRATIOHV,gui2Frm::WxRadioButtonRatioHVClick)
	EVT_RADIOBUTTON(ID_WXRADIOBUTTONAVERARITHLOG,gui2Frm::WxRadioButtonAverArithLogClick)
	EVT_RADIOBUTTON(ID_WXRADIOBUTTONAVERLOG,gui2Frm::WxRadioButtonAverLogClick)
	EVT_RADIOBUTTON(ID_WXRADIOBUTTONHARMONICMEAN,gui2Frm::WxRadioButtonHarmonicMeanClick)
	EVT_BUTTON(ID_WXBUTTONDELSPECSTORAGE,gui2Frm::WxButtonDelSpecStorageClick)
	EVT_BUTTON(ID_WXBUTTONDELVERTCONDUCT,gui2Frm::WxButtonDelVertConductClick)
	EVT_BUTTON(ID_WXBUTTONDELHORCONDUCT,gui2Frm::WxButtonDelHorConductClick)
	EVT_BUTTON(ID_WXBUTTONSAVEPARAMETERSMODFLOW,gui2Frm::WxButtonSaveParametersModflowClick)
	EVT_BUTTON(ID_WXBUTTONINSERTSPECSTORAGE,gui2Frm::WxButtonInsertSpecStorageClick)
	EVT_BUTTON(ID_WXBUTTONINSERTVERTCONDUCT,gui2Frm::WxButtonInsertVertConductClick)
	EVT_BUTTON(ID_WXBUTTONINSERTHORCONDUCT,gui2Frm::WxButtonInsertHorConductClick)
	EVT_BUTTON(ID_WXBUTTONDELSTRESSPERIODS,gui2Frm::WxButtonDelStressPeriodsClick)
	EVT_BUTTON(ID_WXBUTTONDELLAYERBOTTOMS,gui2Frm::WxButtonDelLayerBottomsClick)
	EVT_BUTTON(ID_WXBUTTONSHOWSTRUCTURE,gui2Frm::WxButtonShowStructureClick)
	EVT_BUTTON(ID_WXBUTTONSAVEDISFILE,gui2Frm::WxButtonSaveDisFileClick)
	EVT_BUTTON(ID_WXBUTTONINSERTPERIOD,gui2Frm::WxButtonInsertPeriodClick)
	EVT_BUTTON(ID_WXBUTTONINSERTLAYERBOTTOM,gui2Frm::WxButtonInsertLayerBottomClick)
END_EVENT_TABLE()
////Event Table End

gui2Frm::gui2Frm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

gui2Frm::~gui2Frm()
{
}

void gui2Frm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxNotebookInput = new wxNotebook(this, ID_WXNOTEBOOKINPUT, wxPoint(9, 27), wxSize(693, 315), wxNB_DEFAULT);

	WxNoteBookDiscretization = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKDISCRETIZATION, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookDiscretization, wxT("Discretization"));

	wxArrayString arrayStringFor_WxListBoxNamesLayerBot;
	WxListBoxNamesLayerBot = new wxListBox(WxNoteBookDiscretization, ID_WXLISTBOXNAMESLAYERBOT, wxPoint(75, 40), wxSize(230, 170), arrayStringFor_WxListBoxNamesLayerBot, wxLB_SINGLE | wxVSCROLL | wxHSCROLL);

	WxStaticTextTopLayerBottoms = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTTOPLAYERBOTTOMS, wxT("Top"), wxPoint(25, 37), wxDefaultSize, 0, wxT("WxStaticTextTopLayerBottoms"));
	WxStaticTextTopLayerBottoms->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextBottomLayersBottom = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTBOTTOMLAYERSBOTTOM, wxT("Bottom"), wxPoint(25, 190), wxDefaultSize, 0, wxT("WxStaticTextBottomLayersBottom"));
	WxStaticTextBottomLayersBottom->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextSpatialDiscret = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTSPATIALDISCRET, wxT("Spatial discretization:"), wxPoint(25, 5), wxDefaultSize, 0, wxT("WxStaticTextSpatialDiscret"));
	WxStaticTextSpatialDiscret->SetFont(wxFont(12, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextTimeDiscret = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTTIMEDISCRET, wxT("Time discretization:"), wxPoint(400, 5), wxDefaultSize, 0, wxT("WxStaticTextTimeDiscret"));
	WxStaticTextTimeDiscret->SetFont(wxFont(12, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextEriodsDefStart = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTERIODSDEFSTART, wxT("Start"), wxPoint(400, 37), wxDefaultSize, 0, wxT("WxStaticTextEriodsDefStart"));
	WxStaticTextEriodsDefStart->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextPeriodsDefEnd = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTPERIODSDEFEND, wxT("End"), wxPoint(400, 190), wxDefaultSize, 0, wxT("WxStaticTextPeriodsDefEnd"));
	WxStaticTextPeriodsDefEnd->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	wxArrayString arrayStringFor_WxListBoxStressPeriods;
	WxListBoxStressPeriods = new wxListBox(WxNoteBookDiscretization, ID_WXLISTBOXSTRESSPERIODS, wxPoint(450, 40), wxSize(165, 170), arrayStringFor_WxListBoxStressPeriods, wxLB_SINGLE);

	WxButtonInsertLayerBottom = new wxButton(WxNoteBookDiscretization, ID_WXBUTTONINSERTLAYERBOTTOM, wxT("Insert"), wxPoint(20, 100), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonInsertLayerBottom"));

	WxButtonInsertPeriod = new wxButton(WxNoteBookDiscretization, ID_WXBUTTONINSERTPERIOD, wxT("Insert"), wxPoint(400, 100), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonInsertPeriod"));

	WxButtonSaveDisFile = new wxButton(WxNoteBookDiscretization, ID_WXBUTTONSAVEDISFILE, wxT("Save to MODFLOW"), wxPoint(300, 250), wxSize(120, 25), 0, wxDefaultValidator, wxT("WxButtonSaveDisFile"));

	WxButtonShowStructure = new wxButton(WxNoteBookDiscretization, ID_WXBUTTONSHOWSTRUCTURE, wxT("Show structure"), wxPoint(75, 250), wxSize(88, 25), 0, wxDefaultValidator, wxT("WxButtonShowStructure"));

	WxButtonDelLayerBottoms = new wxButton(WxNoteBookDiscretization, ID_WXBUTTONDELLAYERBOTTOMS, wxT("Delete"), wxPoint(20, 140), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonDelLayerBottoms"));

	WxButtonDelStressPeriods = new wxButton(WxNoteBookDiscretization, ID_WXBUTTONDELSTRESSPERIODS, wxT("Delete"), wxPoint(400, 140), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonDelStressPeriods"));

	wxArrayString arrayStringFor_WxChoiceLengthUnit;
	arrayStringFor_WxChoiceLengthUnit.Add(wxT("undefined"));
	arrayStringFor_WxChoiceLengthUnit.Add(wxT("feet"));
	arrayStringFor_WxChoiceLengthUnit.Add(wxT("meters"));
	arrayStringFor_WxChoiceLengthUnit.Add(wxT("centimeters"));
	WxChoiceLengthUnit = new wxChoice(WxNoteBookDiscretization, ID_WXCHOICELENGTHUNIT, wxPoint(150, 215), wxSize(100, 21), arrayStringFor_WxChoiceLengthUnit, 0, wxDefaultValidator, wxT("WxChoiceLengthUnit"));
	WxChoiceLengthUnit->SetSelection(-1);

	WxStaticTextLengthUnits = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTLENGTHUNITS, wxT("Length units:"), wxPoint(75, 217), wxDefaultSize, 0, wxT("WxStaticTextLengthUnits"));

	WxStaticTextTimeUnits = new wxStaticText(WxNoteBookDiscretization, ID_WXSTATICTEXTTIMEUNITS, wxT("Time units:"), wxPoint(452, 217), wxDefaultSize, 0, wxT("WxStaticTextTimeUnits"));

	wxArrayString arrayStringFor_WxChoiceTimeUnits;
	arrayStringFor_WxChoiceTimeUnits.Add(wxT("undefined"));
	arrayStringFor_WxChoiceTimeUnits.Add(wxT("seconds"));
	arrayStringFor_WxChoiceTimeUnits.Add(wxT("minutes"));
	arrayStringFor_WxChoiceTimeUnits.Add(wxT("hours"));
	arrayStringFor_WxChoiceTimeUnits.Add(wxT("days"));
	arrayStringFor_WxChoiceTimeUnits.Add(wxT("years"));
	WxChoiceTimeUnits = new wxChoice(WxNoteBookDiscretization, ID_WXCHOICETIMEUNITS, wxPoint(514, 215), wxSize(100, 21), arrayStringFor_WxChoiceTimeUnits, 0, wxDefaultValidator, wxT("WxChoiceTimeUnits"));
	WxChoiceTimeUnits->SetSelection(-1);

	WxNoteBookParameters = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKPARAMETERS, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookParameters, wxT("Parameters"));

	wxArrayString arrayStringFor_WxListBoxHorConduct;
	WxListBoxHorConduct = new wxListBox(WxNoteBookParameters, ID_WXLISTBOXHORCONDUCT, wxPoint(20, 60), wxSize(140, 170), arrayStringFor_WxListBoxHorConduct, wxLB_SINGLE | wxVSCROLL | wxHSCROLL);

	WxButtonInsertHorConduct = new wxButton(WxNoteBookParameters, ID_WXBUTTONINSERTHORCONDUCT, wxT("Insert"), wxPoint(20, 35), wxSize(90, 20), 0, wxDefaultValidator, wxT("WxButtonInsertHorConduct"));

	WxStaticTextHorConduct = new wxStaticText(WxNoteBookParameters, ID_WXSTATICTEXTHORCONDUCT, wxT("Horizontal hydraulic cond.:"), wxPoint(20, 10), wxDefaultSize, 0, wxT("WxStaticTextHorConduct"));
	WxStaticTextHorConduct->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextVertConduct = new wxStaticText(WxNoteBookParameters, ID_WXSTATICTEXTVERTCONDUCT, wxT("Vertical hydraulic cond.:"), wxPoint(220, 10), wxDefaultSize, 0, wxT("WxStaticTextVertConduct"));
	WxStaticTextVertConduct->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextSpecificStorage = new wxStaticText(WxNoteBookParameters, ID_WXSTATICTEXTSPECIFICSTORAGE, wxT("Specific storage:"), wxPoint(500, 10), wxDefaultSize, 0, wxT("WxStaticTextSpecificStorage"));
	WxStaticTextSpecificStorage->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	wxArrayString arrayStringFor_WxListBoxVertConduct;
	WxListBoxVertConduct = new wxListBox(WxNoteBookParameters, ID_WXLISTBOXVERTCONDUCT, wxPoint(220, 60), wxSize(140, 170), arrayStringFor_WxListBoxVertConduct, wxLB_SINGLE | wxVSCROLL | wxHSCROLL);

	wxArrayString arrayStringFor_WxListBoxSpecStorage;
	WxListBoxSpecStorage = new wxListBox(WxNoteBookParameters, ID_WXLISTBOXSPECSTORAGE, wxPoint(500, 60), wxSize(140, 170), arrayStringFor_WxListBoxSpecStorage, wxLB_SINGLE | wxVSCROLL | wxHSCROLL);

	WxButtonInsertVertConduct = new wxButton(WxNoteBookParameters, ID_WXBUTTONINSERTVERTCONDUCT, wxT("Insert"), wxPoint(220, 35), wxSize(90, 20), 0, wxDefaultValidator, wxT("WxButtonInsertVertConduct"));

	WxButtonInsertSpecStorage = new wxButton(WxNoteBookParameters, ID_WXBUTTONINSERTSPECSTORAGE, wxT("Insert"), wxPoint(500, 35), wxSize(90, 20), 0, wxDefaultValidator, wxT("WxButtonInsertSpecStorage"));

	WxButtonSaveParametersModflow = new wxButton(WxNoteBookParameters, ID_WXBUTTONSAVEPARAMETERSMODFLOW, wxT("Save to MODFLOW"), wxPoint(300, 250), wxSize(120, 25), 0, wxDefaultValidator, wxT("WxButtonSaveParametersModflow"));

	WxButtonDelHorConduct = new wxButton(WxNoteBookParameters, ID_WXBUTTONDELHORCONDUCT, wxT("Delete"), wxPoint(120, 35), wxSize(40, 20), 0, wxDefaultValidator, wxT("WxButtonDelHorConduct"));

	WxButtonDelVertConduct = new wxButton(WxNoteBookParameters, ID_WXBUTTONDELVERTCONDUCT, wxT("Delete"), wxPoint(320, 35), wxSize(40, 21), 0, wxDefaultValidator, wxT("WxButtonDelVertConduct"));

	WxButtonDelSpecStorage = new wxButton(WxNoteBookParameters, ID_WXBUTTONDELSPECSTORAGE, wxT("Delete"), wxPoint(600, 35), wxSize(40, 19), 0, wxDefaultValidator, wxT("WxButtonDelSpecStorage"));

	wxArrayString arrayStringFor_WxRadioBoxAverKValues;
	WxRadioBoxAverKValues = new wxRadioBox(WxNoteBookParameters, ID_WXRADIOBOXAVERKVALUES, wxT("Averaging method"), wxPoint(372, 50), wxSize(120, 95), arrayStringFor_WxRadioBoxAverKValues, 1, wxRA_SPECIFY_ROWS, wxDefaultValidator, wxT("WxRadioBoxAverKValues"));
//	WxRadioBoxAverKValues->SetSelection(2);

	WxRadioButtonHarmonicMean = new wxRadioButton(WxNoteBookParameters, ID_WXRADIOBUTTONHARMONICMEAN, wxT("Harmonic mean"), wxPoint(375, 65), wxSize(99, 20), wxRB_GROUP, wxDefaultValidator, wxT("WxRadioButtonHarmonicMean"));

	WxRadioButtonAverLog = new wxRadioButton(WxNoteBookParameters, ID_WXRADIOBUTTONAVERLOG, wxT("Logarithmic mean"), wxPoint(375, 85), wxSize(110, 20), 0, wxDefaultValidator, wxT("WxRadioButtonAverLog"));

	WxRadioButtonAverArithLog = new wxRadioButton(WxNoteBookParameters, ID_WXRADIOBUTTONAVERARITHLOG, wxT("Arithmetic + log"), wxPoint(375, 105), wxSize(98, 20), 0, wxDefaultValidator, wxT("WxRadioButtonAverArithLog"));

	wxArrayString arrayStringFor_WxRadioBox1;
	WxRadioBox1 = new wxRadioBox(WxNoteBookParameters, ID_WXRADIOBOX1, wxT("Vertical hydraulic cond."), wxPoint(372, 164), wxSize(120, 63), arrayStringFor_WxRadioBox1, 1, wxRA_SPECIFY_ROWS, wxDefaultValidator, wxT("WxRadioBox1"));
//	WxRadioBox1->SetSelection(1);

	WxRadioButtonRatioHV = new wxRadioButton(WxNoteBookParameters, ID_WXRADIOBUTTONRATIOHV, wxT("Ratio Horiz/Vert"), wxPoint(375, 200), wxSize(98, 16), wxRB_GROUP, wxDefaultValidator, wxT("WxRadioButtonRatioHV"));

	WxRadioButtonVertValues = new wxRadioButton(WxNoteBookParameters, ID_WXRADIOBUTTONVERTVALUES, wxT("Vertical values"), wxPoint(375, 180), wxSize(106, 19), 0, wxDefaultValidator, wxT("WxRadioButtonVertValues"));

	WxStaticTextParamInfoNumLayers = new wxStaticText(WxNoteBookParameters, ID_WXSTATICTEXTPARAMINFONUMLAYERS, wxT(" "), wxPoint(21, 245), wxDefaultSize, 0, wxT("WxStaticTextParamInfoNumLayers"));
	WxStaticTextParamInfoNumLayers->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextParamInfoNumLayers2 = new wxStaticText(WxNoteBookParameters, ID_WXSTATICTEXTPARAMINFONUMLAYERS2, wxT("Layers"), wxPoint(46, 244), wxDefaultSize, 0, wxT("WxStaticTextParamInfoNumLayers2"));
	WxStaticTextParamInfoNumLayers2->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxNoteBookBC = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKBC, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookBC, wxT("Boundary Conditions"));

	wxArrayString arrayStringFor_WxListBoxBoundaryCond;
	WxListBoxBoundaryCond = new wxListBox(WxNoteBookBC, ID_WXLISTBOXBOUNDARYCOND, wxPoint(75, 40), wxSize(230, 170), arrayStringFor_WxListBoxBoundaryCond, wxLB_SINGLE | wxVSCROLL | wxHSCROLL);

	WxButtonInsertBoundaryCond = new wxButton(WxNoteBookBC, ID_WXBUTTONINSERTBOUNDARYCOND, wxT("Insert"), wxPoint(20, 100), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonInsertBoundaryCond"));

	WxButtonClearBoundaryCond = new wxButton(WxNoteBookBC, ID_WXBUTTONCLEARBOUNDARYCOND, wxT("Delete"), wxPoint(20, 140), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonClearBoundaryCond"));

	WxStaticTextTopBoundaryCond = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTTOPBOUNDARYCOND, wxT("Top"), wxPoint(25, 37), wxDefaultSize, 0, wxT("WxStaticTextTopBoundaryCond"));
	WxStaticTextTopBoundaryCond->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextBottomBoundaryCond = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTBOTTOMBOUNDARYCOND, wxT("Bottom"), wxPoint(25, 190), wxDefaultSize, 0, wxT("WxStaticTextBottomBoundaryCond"));
	WxStaticTextBottomBoundaryCond->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextBoundariesBoundaryCond = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTBOUNDARIESBOUNDARYCOND, wxT("Boundary conditions:"), wxPoint(25, 5), wxDefaultSize, 0, wxT("WxStaticTextBoundariesBoundaryCond"));
	WxStaticTextBoundariesBoundaryCond->SetFont(wxFont(12, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextInitialHead = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTINITIALHEAD, wxT("Initial heads:"), wxPoint(365, 5), wxDefaultSize, 0, wxT("WxStaticTextInitialHead"));
	WxStaticTextInitialHead->SetFont(wxFont(12, wxSWISS, wxNORMAL, wxBOLD, false));

	wxArrayString arrayStringFor_WxListBoxInitialHeads;
	WxListBoxInitialHeads = new wxListBox(WxNoteBookBC, ID_WXLISTBOXINITIALHEADS, wxPoint(420, 40), wxSize(230, 170), arrayStringFor_WxListBoxInitialHeads, wxLB_SINGLE | wxVSCROLL | wxHSCROLL);

	WxButtonInsertInitialHeads = new wxButton(WxNoteBookBC, ID_WXBUTTONINSERTINITIALHEADS, wxT("Insert"), wxPoint(365, 100), wxSize(51, 25), 0, wxDefaultValidator, wxT("WxButtonInsertInitialHeads"));

	WxButtonClearInitialHeads = new wxButton(WxNoteBookBC, ID_WXBUTTONCLEARINITIALHEADS, wxT("Delete"), wxPoint(365, 140), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonClearInitialHeads"));

	WxButtonSaveBoundaryCondInitialHeads = new wxButton(WxNoteBookBC, ID_WXBUTTONSAVEBOUNDARYCONDINITIALHEADS, wxT("Save to MODFLOW"), wxPoint(300, 250), wxSize(120, 25), 0, wxDefaultValidator, wxT("WxButtonSaveBoundaryCondInitialHeads"));

	WxStaticTextTopInitialHeads = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTTOPINITIALHEADS, wxT("Top"), wxPoint(365, 37), wxDefaultSize, 0, wxT("WxStaticTextTopInitialHeads"));
	WxStaticTextTopInitialHeads->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextBottomInitialHeads = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTBOTTOMINITIALHEADS, wxT("Bottom"), wxPoint(365, 192), wxDefaultSize, 0, wxT("WxStaticTextBottomInitialHeads"));
	WxStaticTextBottomInitialHeads->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextInfoUnmLayers = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTINFOUNMLAYERS, wxT("Layers"), wxPoint(97, 240), wxDefaultSize, 0, wxT("WxStaticTextInfoUnmLayers"));
	WxStaticTextInfoUnmLayers->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextInfoNumLayersCount = new wxStaticText(WxNoteBookBC, ID_WXSTATICTEXTINFONUMLAYERSCOUNT, wxT(" "), wxPoint(61, 240), wxDefaultSize, 0, wxT("WxStaticTextInfoNumLayersCount"));
	WxStaticTextInfoNumLayersCount->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxNoteBookZB = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKZB, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookZB, wxT("Recharge+Wells"));

	WxStaticTextRechWellsStressPeriodInfo = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTRECHWELLSSTRESSPERIODINFO, wxT("Stress Periods"), wxPoint(120, 250), wxDefaultSize, 0, wxT("WxStaticTextRechWellsStressPeriodInfo"));
	WxStaticTextRechWellsStressPeriodInfo->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextRechWellNUmStressPeriods = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTRECHWELLNUMSTRESSPERIODS, wxT(" "), wxPoint(75, 250), wxDefaultSize, 0, wxT("WxStaticTextRechWellNUmStressPeriods"));
	WxStaticTextRechWellNUmStressPeriods->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxButtonRechInsert = new wxButton(WxNoteBookZB, ID_WXBUTTONRECHINSERT, wxT("Insert"), wxPoint(20, 100), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonRechInsert"));

	wxArrayString arrayStringFor_WxChoiceRechUnits;
	arrayStringFor_WxChoiceRechUnits.Add(wxT("mm/a"));
	arrayStringFor_WxChoiceRechUnits.Add(wxT("cm/d"));
	arrayStringFor_WxChoiceRechUnits.Add(wxT("mm/d"));
	arrayStringFor_WxChoiceRechUnits.Add(wxT("m/s"));
	arrayStringFor_WxChoiceRechUnits.Add(wxT("m/d"));
	WxChoiceRechUnits = new wxChoice(WxNoteBookZB, ID_WXCHOICERECHUNITS, wxPoint(175, 215), wxSize(100, 21), arrayStringFor_WxChoiceRechUnits, 0, wxDefaultValidator, wxT("WxChoiceRechUnits"));
	WxChoiceRechUnits->SetSelection(-1);

	wxArrayString arrayStringFor_WxListBoxRech;
	WxListBoxRech = new wxListBox(WxNoteBookZB, ID_WXLISTBOXRECH, wxPoint(75, 40), wxSize(230, 170), arrayStringFor_WxListBoxRech, wxLB_SINGLE);

	WxButtonRechClear = new wxButton(WxNoteBookZB, ID_WXBUTTONRECHCLEAR, wxT("Delete"), wxPoint(20, 140), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonRechClear"));

	WxStaticTextRechStart = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTRECHSTART, wxT("Start"), wxPoint(25, 37), wxDefaultSize, 0, wxT("WxStaticTextRechStart"));
	WxStaticTextRechStart->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextRechEnd = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTRECHEND, wxT("End"), wxPoint(25, 190), wxDefaultSize, 0, wxT("WxStaticTextRechEnd"));
	WxStaticTextRechEnd-> SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextRechargeCaption = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTRECHARGECAPTION, wxT("Recharge:"), wxPoint(25, 5), wxDefaultSize, 0, wxT("WxStaticTextRechargeCaption"));
	WxStaticTextRechargeCaption->SetFont(wxFont(12, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextWellsCaption = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTWELLSCAPTION, wxT("Wells:"), wxPoint(365, 5), wxDefaultSize, 0, wxT("WxStaticTextWellsCaption"));
	WxStaticTextWellsCaption->SetFont(wxFont(12, wxSWISS, wxNORMAL, wxBOLD, false));

	wxArrayString arrayStringFor_WxListBoxWells;
	WxListBoxWells = new wxListBox(WxNoteBookZB, ID_WXLISTBOXWELLS, wxPoint(420, 40), wxSize(230, 170), arrayStringFor_WxListBoxWells, wxLB_SINGLE);

	WxButtonWellsInsert = new wxButton(WxNoteBookZB, ID_WXBUTTONWELLSINSERT, wxT("Insert"), wxPoint(365, 100), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonWellsInsert"));

	WxButtonWellsDelete = new wxButton(WxNoteBookZB, ID_WXBUTTONWELLSDELETE, wxT("Delete"), wxPoint(365, 140), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonWellsDelete"));

	wxArrayString arrayStringFor_WxChoiceDischargUnits;
	arrayStringFor_WxChoiceDischargUnits.Add(wxT("m3/d"));
	arrayStringFor_WxChoiceDischargUnits.Add(wxT("m3/a"));
	arrayStringFor_WxChoiceDischargUnits.Add(wxT("m3/s"));
	arrayStringFor_WxChoiceDischargUnits.Add(wxT("l/d"));
	arrayStringFor_WxChoiceDischargUnits.Add(wxT("l/a"));
	arrayStringFor_WxChoiceDischargUnits.Add(wxT("l/s"));
	WxChoiceDischargUnits = new wxChoice(WxNoteBookZB, ID_WXCHOICEDISCHARGUNITS, wxPoint(520, 215), wxSize(100, 21), arrayStringFor_WxChoiceDischargUnits, 0, wxDefaultValidator, wxT("WxChoiceDischargUnits"));
	WxChoiceDischargUnits->SetSelection(-1);

	WxStaticTextWellsStart = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTWELLSSTART, wxT("Start"), wxPoint(365, 37), wxDefaultSize, 0, wxT("WxStaticTextWellsStart"));
	WxStaticTextWellsStart->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextWellsEnd = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTWELLSEND, wxT("End"), wxPoint(365, 190), wxDefaultSize, 0, wxT("WxStaticTextWellsEnd"));
	WxStaticTextWellsEnd->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxBOLD, false));

	WxButtonRechWellsSaveModflow = new wxButton(WxNoteBookZB, ID_WXBUTTONRECHWELLSSAVEMODFLOW, wxT("Save to MODFLOW"), wxPoint(300, 250), wxSize(120, 25), 0, wxDefaultValidator, wxT("WxButtonRechWellsSaveModflow"));

	WxStaticTextRechUnits = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTRECHUNITS, wxT("Recharge Units:"), wxPoint(75, 217), wxDefaultSize, 0, wxT("WxStaticTextRechUnits"));
	WxStaticTextRechUnits ->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextDischargeUnits = new wxStaticText(WxNoteBookZB, ID_WXSTATICTEXTDISCHARGEUNITS, wxT("Discharge Units:"), wxPoint(424, 217), wxDefaultSize, 0, wxT("WxStaticTextDischargeUnits"));
	WxStaticTextDischargeUnits->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false));

	WxNoteBookoC = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKOC, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookoC, wxT("Output Control"));

	WxStaticTextSaveResPeriods = new wxStaticText(WxNoteBookoC, ID_WXSTATICTEXTSAVERESPERIODS, wxT("Save stress periods:"), wxPoint(25, 20), wxDefaultSize, 0, wxT("WxStaticTextSaveResPeriods"));

	wxArrayString arrayStringFor_WxListBoxSaveResStressPeriods;
	WxListBoxSaveResStressPeriods = new wxListBox(WxNoteBookoC, ID_WXLISTBOXSAVERESSTRESSPERIODS, wxPoint(150, 20), wxSize(50, 150), arrayStringFor_WxListBoxSaveResStressPeriods, wxLB_SINGLE | wxWANTS_CHARS);

	WxCheckBoxSaveResAllStressPeriods = new wxCheckBox(WxNoteBookoC, ID_WXCHECKBOXSAVERESALLSTRESSPERIODS, wxT("Save all stress periods"), wxPoint(20, 185), wxSize(147, 28), 0, wxDefaultValidator, wxT("WxCheckBoxSaveResAllStressPeriods"));

	WxStaticTextSaveResLayers = new wxStaticText(WxNoteBookoC, ID_WXSTATICTEXTSAVERESLAYERS, wxT("Save results for layers:"), wxPoint(420, 20), wxDefaultSize, 0, wxT("WxStaticTextSaveResLayers"));

	wxArrayString arrayStringFor_WxListBoxSaveResLayers;
	WxListBoxSaveResLayers = new wxListBox(WxNoteBookoC, ID_WXLISTBOXSAVERESLAYERS, wxPoint(550, 20), wxSize(50, 150), arrayStringFor_WxListBoxSaveResLayers, wxLB_SINGLE);

	WxCheckBoxSaveResAllLayers = new wxCheckBox(WxNoteBookoC, ID_WXCHECKBOXSAVERESALLLAYERS, wxT("Save results for all layers"), wxPoint(420, 185), wxSize(157, 25), 0, wxDefaultValidator, wxT("WxCheckBoxSaveResAllLayers"));

	WxButtonSaveOutputControl = new wxButton(WxNoteBookoC, ID_WXBUTTONSAVEOUTPUTCONTROL, wxT("Save to MODFLOW"), wxPoint(300, 250), wxSize(120, 25), 0, wxDefaultValidator, wxT("WxButtonSaveOutputControl"));

	WxButtonAddSavePeriod = new wxButton(WxNoteBookoC, ID_WXBUTTONADDSAVEPERIOD, wxT("Add"), wxPoint(80, 80), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonAddSavePeriod"));

	WxButtonAddSaveLayer = new wxButton(WxNoteBookoC, ID_WXBUTTONADDSAVELAYER, wxT("Add"), wxPoint(480, 85), wxSize(50, 25), 0, wxDefaultValidator, wxT("WxButtonAddSaveLayer"));

	WxNoteBookP_Ex = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKP_EX, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookP_Ex, wxT("Proof+Export"));

	WxStaticTextOuterIterations = new wxStaticText(WxNoteBookP_Ex, ID_WXSTATICTEXTOUTERITERATIONS, wxT("Max. number of outer iterations:"), wxPoint(10, 15), wxDefaultSize, 0, wxT("WxStaticTextOuterIterations"));

	WxStaticTextInnerIterations = new wxStaticText(WxNoteBookP_Ex, ID_WXSTATICTEXTINNERITERATIONS, wxT("Number of inner iterations:"), wxPoint(10, 45), wxDefaultSize, 0, wxT("WxStaticTextInnerIterations"));

	WxStaticTextHeadChange = new wxStaticText(WxNoteBookP_Ex, ID_WXSTATICTEXTHEADCHANGE, wxT("Head change criterion:"), wxPoint(10, 75), wxDefaultSize, 0, wxT("WxStaticTextHeadChange"));

	WxStaticTextHeadChangeM = new wxStaticText(WxNoteBookP_Ex, ID_WXSTATICTEXTHEADCHANGEM, wxT("[m]"), wxPoint(240, 75), wxDefaultSize, 0, wxT("WxStaticTextHeadChangeM"));

	WxStaticTextResidualCriterion = new wxStaticText(WxNoteBookP_Ex, ID_WXSTATICTEXTRESIDUALCRITERION, wxT("Residual criterion:"), wxPoint(10, 105), wxDefaultSize, 0, wxT("WxStaticTextResidualCriterion"));

	WxStaticTextResidualCriterionUnit = new wxStaticText(WxNoteBookP_Ex, ID_WXSTATICTEXTRESIDUALCRITERIONUNIT, wxT("[m�/s]"), wxPoint(240, 105), wxDefaultSize, 0, wxT("WxStaticTextResidualCriterionUnit"));

	WxEditOuterIter = new wxTextCtrl(WxNoteBookP_Ex, ID_WXEDITOUTERITER, wxT(""), wxPoint(180, 10), wxSize(45, 20), 0, wxDefaultValidator, wxT("WxEditOuterIter"));

	WxEditInnerIterations = new wxTextCtrl(WxNoteBookP_Ex, ID_WXEDITINNERITERATIONS, wxT(""), wxPoint(180, 45), wxSize(45, 20), 0, wxDefaultValidator, wxT("WxEditInnerIterations"));

	WxEditHeadChangeCrit = new wxTextCtrl(WxNoteBookP_Ex, ID_WXEDITHEADCHANGECRIT, wxT(""), wxPoint(180, 75), wxSize(45, 20), 0, wxDefaultValidator, wxT("WxEditHeadChangeCrit"));

	WxEditResidualCrit = new wxTextCtrl(WxNoteBookP_Ex, ID_WXEDITRESIDUALCRIT, wxT(""), wxPoint(180, 105), wxSize(45, 20), 0, wxDefaultValidator, wxT("WxEditResidualCrit"));

	WxButtonSaveRunModflow = new wxButton(WxNoteBookP_Ex, ID_WXBUTTONSAVERUNMODFLOW, wxT("Save + Run MODFLOW"), wxPoint(300, 250), wxSize(130, 25), 0, wxDefaultValidator, wxT("WxButtonSaveRunModflow"));

	WxButtonTransferToGIS = new wxButton(WxNoteBookP_Ex, ID_WXBUTTONTRANSFERTOGIS, wxT("Transfer results to GIS"), wxPoint(484, 247), wxSize(139, 26), 0, wxDefaultValidator, wxT("WxButtonTransferToGIS"));

	WxNoteBookModpath = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKMODPATH, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookModpath, wxT("Modpath"));

	WxNoteBookSolver = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKSOLVER, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookSolver, wxT("Solver"));

	WxNoteBookObs = new wxPanel(WxNotebookInput, ID_WXNOTEBOOKOBS, wxPoint(4, 24), wxSize(685, 287));
	WxNotebookInput->AddPage(WxNoteBookObs, wxT("Obs-Points"));

	WxOpenFileDialogBottoms =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.*"));

	WxOpenFileDialogInitialHeads =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.*"));

	wxArrayString arrayStringFor_WxMultiChoiceDialogAddSavePeriodsLayers;
	WxMultiChoiceDialogAddSavePeriodsLayers =  new wxMultiChoiceDialog(this, wxT(""), wxT("Multiple Choice List"), arrayStringFor_WxMultiChoiceDialogAddSavePeriodsLayers);

	WxMenuBarTop = new wxMenuBar();
	wxMenu *ID_MNU_FILE_1029_Mnu_Obj = new wxMenu(wxT("sgfhsfh"),0);
	ID_MNU_FILE_1029_Mnu_Obj->Append(ID_MNU_NEWPROJECT_1119, wxT("New Project"), wxT(""), wxITEM_NORMAL);
	ID_MNU_FILE_1029_Mnu_Obj->Append(ID_MNU_OPENPROJECT_1030, wxT("Open Project"), wxT(""), wxITEM_NORMAL);
	ID_MNU_FILE_1029_Mnu_Obj->Append(ID_MNU_SAVEPROJECT_1031, wxT("Save Project"), wxT(""), wxITEM_NORMAL);
	ID_MNU_FILE_1029_Mnu_Obj->Append(ID_MNU_SAVEPROJECTAS_1038, wxT("Save Project As"), wxT(""), wxITEM_NORMAL);
	ID_MNU_FILE_1029_Mnu_Obj->Append(ID_MNU_EXIT_1032, wxT("Exit"), wxT(""), wxITEM_NORMAL);
	WxMenuBarTop->Append(ID_MNU_FILE_1029_Mnu_Obj, wxT("File"));

	wxMenu *ID_MNU_HELP_1033_Mnu_Obj = new wxMenu(wxT("sgfhsfh"),0);
	ID_MNU_HELP_1033_Mnu_Obj->Append(ID_MNU_HELPTOPICS_1034, wxT("Help Topics"), wxT(""), wxITEM_NORMAL);
	ID_MNU_HELP_1033_Mnu_Obj->Append(ID_MNU_MANUAL_1035, wxT("Manual"), wxT(""), wxITEM_NORMAL);
	ID_MNU_HELP_1033_Mnu_Obj->Append(ID_MNU_ABOUT_1036, wxT("About"), wxT(""), wxITEM_NORMAL);
	WxMenuBarTop->Append(ID_MNU_HELP_1033_Mnu_Obj, wxT("Help"));
	SetMenuBar(WxMenuBarTop);

	WxOpenFileDialogBoundaryCond =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.*"));

	WxOpenProjFileDialog =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.prj"));
	WxSaveProjFileDialog =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.prj"), 1);
	WxSaveAsProjFileDialog =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.prj"), 1);

	SetTitle(wxT("MO2GEO: GIS - MODFLOW Interface"));
	SetIcon(wxNullIcon);
	SetSize(8,8,753,381);
	Center();

	////GUI Items Creation End
}

void gui2Frm::OnClose(wxCloseEvent& event)
{
	Destroy();
}


/*
 * Mnuopenproject1030Click
 */
void gui2Frm::Mnuopenproject1030Click(wxCommandEvent& event)
{
	// insert your code here
  int fileDialogShow;
  long counter;
  int a;

  wxString projectPathName, projectFileName;
  string strContentInputFile;
  projectFileAnalysis pfa;
  fileDialogShow=WxOpenProjFileDialog->ShowModal();
  projectPathName=WxOpenProjFileDialog->GetPath();

  ifstream fin(projectPathName);
  getline(fin, strContentInputFile, '\t');
  fin.close();

  pfa.analyzeProjectFileContent(strContentInputFile);
//  cout<<strContentInputFile<<endl;

//  projectFileAnalysis pfa;

  intNPER= pfa.getIntNPER();
  intITMUNI= pfa.getIntITMUNI();
  intLENUNI= pfa.getIntLENUNI();
  intNLAY= pfa.getIntNLAY();
  intNROW= pfa.getIntNROW();
  intNCOL= pfa.getIntNCOL();


  long *intNSTP=new long[intNPER+1];
  pfa.getIntNSTP(intNSTP);

  intTSMULT= pfa.getIntTSMULT();
  intSAVEPERIODS= pfa.getIntSAVEPERIODS();
  dblPERLEN= pfa.getDblPERLEN();
  dblTMUNIMULT= pfa.getDblTMUNIMULT();
  dblLENUNIMULT= pfa.getDblLENUNIMULT();
  dblXDist= pfa.getDblXDist();
  dblYDist= pfa.getDblYDist();
  dblRechargeMult= pfa.getDblRechargeMult();
  dblDischargeMult= pfa.getDblDischargeMult();
  dblXMin= pfa.getDblXMin();
  dblYMin= pfa.getDblYMin();
  pathProjectFile= pfa.getStrPathProjectFile();
  pathProjectFilePre= pfa.getStrPathProjectFilePre();
  pathProjectFilePost= pfa.getStrPathProjectFilePost();
  pathProjectFileEx= pfa.getStrPathProjectFileEx();
  wxstrLayerType= pfa.getStrLayerType();
  wxstrLayerAverage= pfa.getStrLayerAverage();
  wxstrChani= pfa.getStrChani();
  wxstrVerticalK= pfa.getStrVerticalK();
  wxstrWetting= pfa.getStrWetting();

  int *intConstantHKValueFlag=new int[intNLAY];
  int *intConstantVKValueFlag=new int[intNLAY];
  int *intConstantSSValueFlag=new int[intNLAY];
  double *dblConstantHKValue=new double[intNLAY];
  double *dblConstantVKValue=new double[intNLAY];
  double *dblConstantSSValue=new double[intNLAY];

  pfa.getConductivityFlags(intConstantHKValueFlag, intConstantVKValueFlag, intConstantSSValueFlag);
  pfa.getConductivityValues(dblConstantHKValue, dblConstantVKValue, dblConstantSSValue);

  intPointsPerSlice= pfa.getIntPointsPerSlice();

  int *intConstantRechValueFlag=new int[intNPER];
  double *dblConstantRechValue=new double[intNPER];

  pfa.getConstRecharge(intConstantRechValueFlag, dblConstantRechValue);

  intSaveAllLayers= pfa.getOCSaveAllLayers();
  intSaveAllPeriods= pfa.getOCSaveAllPeriods();
  intSaveLayers= pfa.getOCSaveSingleLayer();
  intSavePeriods= pfa.getOCSaveSinglePeriod();
  wxstrProjName= pfa.getStrProjName();

  double *dblStressPLength=new double[intNPER];
  double *dblTimeStepLength=new double[intNPER];
  int *intTimeMode=new int[intNPER];

  pfa.getStressPeriodData(dblStressPLength, dblTimeStepLength, intTimeMode);

  for(counter=0;counter<intNPER;counter++)
  {
    cout<<dblStressPLength[counter]<<endl;
    vStressPeriodLength.push_back(dblStressPLength[counter]);
    vTimeStepLength.push_back(dblTimeStepLength[counter]);
    vTimeMode.push_back(intTimeMode[counter]);
    cout<<vStressPeriodLength[counter]<<endl;
  }


  WxListBoxNamesLayerBot->AppendString(pfa.getTopLayer());

  wxString *wxstrLayBot=new wxString[intNLAY];
  wxString *wxstrHorConduct=new wxString[intNLAY];
  wxString *wxstrVertConduct=new wxString[intNLAY];
  wxString *wxstrSpecStor=new wxString[intNLAY];
  wxString *wxstrBC=new wxString[intNLAY];
  wxString *wxstrIH=new wxString[intNLAY];

  pfa.getLayerParameters(wxstrLayBot, wxstrHorConduct, wxstrVertConduct, wxstrSpecStor, wxstrBC, wxstrIH);

  WxListBoxNamesLayerBot->AppendString(wxstrLayBot[0]);

  for(counter=0;counter<intNLAY-1;counter++)
  {
    WxListBoxNamesLayerBot->AppendString(wxstrLayBot[counter+1]);
    WxListBoxHorConduct->AppendString(wxstrHorConduct[counter]);
    WxListBoxVertConduct->AppendString(wxstrVertConduct[counter]);
    WxListBoxSpecStorage->AppendString(wxstrSpecStor[counter]);
    WxListBoxBoundaryCond->AppendString(wxstrBC[counter]);
    WxListBoxInitialHeads->AppendString(wxstrIH[counter]);
  }

  wxString *strStreePeriod=new wxString[intNPER];
  double *dblTimeStepLength2=new double[intNPER];
  int *intTimeMode2=new int[intNPER];
  wxString *strRech=new wxString[intNPER];
  wxString *strWells=new wxString[intNPER];

  pfa.getPeriodParameters(strStreePeriod, dblTimeStepLength2, intTimeMode2, strRech, strWells);

  for(counter=0;counter<intNPER;counter++)
  {
//    wxString wxstrSP;
    WxListBoxRech->AppendString(strRech[counter]);
    WxListBoxWells->AppendString(strWells[counter]);
  }

  for(counter=0;counter<intNPER;counter++)
  {
    wxString wxstrSP;
    wxstrSP<<strStreePeriod[counter];
    WxListBoxStressPeriods->AppendString(wxstrSP);
  }


  WxListBoxSaveResLayers->AppendString(pfa.getSaveResLayer());
  WxListBoxSaveResStressPeriods->AppendString(pfa.getSaveResStrePer());
  WxEditOuterIter->AppendText(pfa.getOuterIter());
  WxEditInnerIterations->AppendText(pfa.getInnerIter());
  WxEditHeadChangeCrit->AppendText(pfa.getHeadChangeCrit());
  WxEditResidualCrit->AppendText(pfa.getResCrit());

}

/*
 * Mnusaveproject1031Click
 */
void gui2Frm::Mnusaveproject1031Click(wxCommandEvent& event)
{
	// insert your code here
	wxMessageBox("Please use SaveAs");
}

/*
 * Mnuexit1032Click
 */
void gui2Frm::Mnuexit1032Click(wxCommandEvent& event)
{
	// insert your code here
	Destroy();
}

/*
 * Mnuhelptopics1034Click
 */
void gui2Frm::Mnuhelptopics1034Click(wxCommandEvent& event)
{
	// insert your code here
}

/*
 * Mnumanual1035Click
 */
void gui2Frm::Mnumanual1035Click(wxCommandEvent& event)
{
	// insert your code here
	wxMessageBox("Manual");
}

/*
 * Mnuabout1036Click
 */
void gui2Frm::Mnuabout1036Click(wxCommandEvent& event)
{
	// insert your code here
	wxMessageBox("(C) by Wolfgang Gossel (2011), GPL (General Public License v. 3)");
}



/*
 * Mnusaveprojectas1038Click
 */
void gui2Frm::Mnusaveprojectas1038Click(wxCommandEvent& event)
{
	// insert your code here
  int fileDialogShow, counter;
  wxString projectPathName, projectFileName;
  wxString strSaveString;

  //"global" data save start
  strSaveString<<intNPER<<"\n";			//1
  strSaveString<<intITMUNI<<"\n";		//2
  strSaveString<<intLENUNI<<"\n";		//3
  strSaveString<<intNLAY<<"\n";			//4
  strSaveString<<intNROW<<"\n";			//5
  strSaveString<<intNCOL<<"\n";			//6

  for(counter=0;counter<intNPER;counter++)
  {
    strSaveString<<intNSTP[counter]<<"\n";
  }

  strSaveString<<intTSMULT<<"\n";		//1
  strSaveString<<intSAVEPERIODS<<"\n";		//2
  strSaveString<<dblPERLEN<<"\n";		//3
  strSaveString<<dblTMUNIMULT<<"\n";		//4
  strSaveString<<dblLENUNIMULT<<"\n";		//5
  strSaveString<<dblXDist<<"\n";		//6
  strSaveString<<dblYDist<<"\n";		//7
  strSaveString<<dblRechargeMult<<"\n";		//8
  strSaveString<<dblDischargeMult<<"\n";	//9
  strSaveString<<dblXMin<<"\n";			//10
  strSaveString<<dblYMin<<"\n";			//11
  strSaveString<<pathProjectFile<<"\n";		//12
  strSaveString<<pathProjectFilePre<<"\n";	//13
  strSaveString<<pathProjectFilePost<<"\n";	//14
  strSaveString<<pathProjectFileEx<<"\n";	//15
  strSaveString<<wxstrLayerType<<"\n";		//16
  strSaveString<<wxstrLayerAverage<<"\n";	//17
  strSaveString<<wxstrChani<<"\n";		//18
  strSaveString<<wxstrVerticalK<<"\n";		//19
  strSaveString<<wxstrWetting<<"\n";		//20

  for(counter=0;counter<intNLAY-1;counter++)
  {
    strSaveString<<intConstantHKValueFlag[counter]<<"\n";
    strSaveString<<intConstantVKValueFlag[counter]<<"\n";
    strSaveString<<intConstantSSValueFlag[counter]<<"\n";
    strSaveString<<dblConstantHKValue[counter]<<"\n";
    strSaveString<<dblConstantVKValue[counter]<<"\n";
    strSaveString<<dblConstantSSValue[counter]<<"\n";
  }

  strSaveString<<intPointsPerSlice<<"\n";

  for(counter=0;counter<intNPER;counter++)
  {
    strSaveString<<intConstantRechValueFlag[counter]<<"\n";
    strSaveString<<dblConstantRechValue[counter]<<"\n";
  }

  strSaveString<<intSaveAllLayers<<"\n";
  strSaveString<<intSaveAllPeriods<<"\n";
  strSaveString<<intSaveLayers<<"\n";
  strSaveString<<intSavePeriods<<"\n";
  strSaveString<<wxstrProjName<<"\n";

  for(counter=0;counter<intNPER;counter++)
  {
    strSaveString<<vStressPeriodLength[counter]<<"\n";
    strSaveString<<vTimeStepLength[counter]<<"\n";
    strSaveString<<vTimeMode[counter]<<"\n";
  }

  //"global" data save end

  //data from dialogs start

  strSaveString<<WxListBoxNamesLayerBot->GetString(0)<<"\n";

  for(counter=0;counter<intNLAY-1;counter++)
  {
    strSaveString<<WxListBoxNamesLayerBot->GetString(counter+1)<<"\n";
    strSaveString<<WxListBoxHorConduct->GetString(counter)<<"\n";
    strSaveString<<WxListBoxVertConduct->GetString(counter)<<"\n";
    strSaveString<<WxListBoxSpecStorage->GetString(counter)<<"\n";
    strSaveString<<WxListBoxBoundaryCond->GetString(counter)<<"\n";
    strSaveString<<WxListBoxInitialHeads->GetString(counter)<<"\n";
  }

  for(counter=0;counter<intNPER;counter++)
  {
    strSaveString<<WxListBoxStressPeriods->GetString(counter)<<"\n";
    strSaveString<<vTimeStepLength[counter]<<"\n";
    strSaveString<<vTimeMode[counter]<<"\n";
    strSaveString<<WxListBoxRech->GetString(counter)<<"\n";
    strSaveString<<WxListBoxWells->GetString(counter)<<"\n";

  }

      strSaveString<<WxListBoxSaveResLayers->GetString(0)<<"\n";
      strSaveString<<WxListBoxSaveResStressPeriods->GetString(0)<<"\n";

  strSaveString<<WxEditOuterIter->GetValue()<<"\n";
  strSaveString<<WxEditInnerIterations->GetValue()<<"\n";
  strSaveString<<WxEditHeadChangeCrit->GetValue()<<"\n";
  strSaveString<<WxEditResidualCrit->GetValue()<<"\n";

//
//  WxChoiceLengthUnit->SetSelection(-1);
//  WxChoiceTimeUnits->SetSelection(-1);


//  WxRadioBoxAverKValues
//  WxRadioBox1

//
//
//  WxChoiceRechUnits
//
//
//  WxChoiceDischargUnits
//
//  WxCheckBoxSaveResAllStressPeriods
//
//  WxCheckBoxSaveResAllLayers
//  WxEditOuterIter
//  WxEditInnerIterations
//  WxEditHeadChangeCrit
//  WxEditResidualCrit

  //data from dialogs end

  fileDialogShow=WxSaveAsProjFileDialog->ShowModal();
  projectPathName=WxSaveAsProjFileDialog->GetPath();
  ofstream outProjectFile(projectPathName);
  outProjectFile<<strSaveString;
  outProjectFile.close();
}

/*
 * WxButtonInsertPeriodClick
 */
void gui2Frm::WxButtonInsertPeriodClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxstrPeriodLength, wxstrTimeStepLength, wxstrMode, tmpString;
	double dblPeriodLength, dblTimeStepLength;
	int intNumberPeriod;
	int intTimeMode;
	//intNPER=intNPER+1;
	intNumberPeriod=WxListBoxStressPeriods->GetCount();
	intNumberPeriod=intNumberPeriod+1;
	TimePeriodSettings* dialogTimePerSet = new TimePeriodSettings(NULL);
	dialogTimePerSet->ShowModal();
	wxstrPeriodLength=dialogTimePerSet->getPeriodLength();
	wxstrTimeStepLength=dialogTimePerSet->getTimeStepLength();
	wxstrMode=dialogTimePerSet->getMode();
	intTimeMode=dialogTimePerSet->getModeInt();
	WxListBoxStressPeriods->AppendString(wxstrPeriodLength<<" "<<wxstrTimeStepLength<<" "<<wxstrMode);
	if(!wxstrPeriodLength.ToDouble(&dblPeriodLength)){ /* error! */ }
	if(!wxstrTimeStepLength.ToDouble(&dblTimeStepLength)){ /* error! */ }
	vStressPeriodLength.push_back(dblPeriodLength);
	vTimeStepLength.push_back(dblTimeStepLength);
	vTimeMode.push_back(intTimeMode);
	//dblPERLEN=dblPeriodLength;
	intNPER=WxListBoxStressPeriods->GetCount();
}

/*
 * WxButtonInsertLayerBottomClick
 */
void gui2Frm::WxButtonInsertLayerBottomClick(wxCommandEvent& event)
{
	// insert your code here
	wxString pathASCIIBottomGrid, tmpString;
	int bottomGridOpenShow, numberLayers;
	bottomGridOpenShow=WxOpenFileDialogBottoms->ShowModal();
	pathASCIIBottomGrid=WxOpenFileDialogBottoms->GetPath();
	WxListBoxNamesLayerBot->AppendString(pathASCIIBottomGrid);
	numberLayers=WxListBoxNamesLayerBot->GetCount();

	intNLAY=numberLayers;
}

/*
 * WxButtonShowStructureClick
 */
void gui2Frm::WxButtonShowStructureClick(wxCommandEvent& event)
{
	// insert your code here
    wxMessageBox("Only preliminary yet");
    wxString wxstrProjectExport;
    long intNumberLay;

    intNumberLay=WxListBoxNamesLayerBot->GetCount();

    wxString wxFileName;

    wxstrProjectExport<<intNumberLay<<" EG\n";

    for(long intExportLayers=0;intExportLayers<intNumberLay;intExportLayers++)
    {
      wxFileName="";
      wxFileName=WxListBoxNamesLayerBot->GetString(intExportLayers);
      wxstrProjectExport<<"EG "<<wxFileName<<"\n";
    }

    wxstrProjectExport<<"70\n"; //angle
    wxstrProjectExport<<"30\n"; //angle
    wxstrProjectExport<<"10000\n"; //hor. scale
    wxstrProjectExport<<"5000\n"; //vert. scale
    wxstrProjectExport<<"500\n"; //offset
    wxstrProjectExport<<"C:\\\n"; //Cross section line path/file
    wxstrProjectExport<<"8000\n"; //hor. scale cross section
    wxstrProjectExport<<"2000\n"; //vert. scale cross section
    wxstrProjectExport<<"2000\n"; //X-Coord. borehole location
    wxstrProjectExport<<"2000\n"; //Y-Coord. borehole location
    wxstrProjectExport<<"500\n"; //vert. scale borehole location

    wxString wxstrPathFileNameViewerPrj;
    int viewerProjOpenShow;
	viewerProjOpenShow=WxOpenFileDialogBottoms->ShowModal();
	wxstrPathFileNameViewerPrj=WxOpenFileDialogBottoms->GetPath();
    wxstrPathFileNameViewerPrj<<".prj";
    ofstream outFile(wxstrPathFileNameViewerPrj);//"D:\\mo2geo\\stable\\mf_export.prj");
    outFile<<wxstrProjectExport;
    outFile.close();
}

/*
 * WxButtonDelLayerBottomsClick
 */
void gui2Frm::WxButtonDelLayerBottomsClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxNamesLayerBot->Clear();
	intNLAY=0;
}

/*
 * WxButtonDelStressPeriodsClick
 */
void gui2Frm::WxButtonDelStressPeriodsClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxStressPeriods->Clear();
	intNPER=0;
}

/*
 * WxButtonSaveDisFileClick
 */
void gui2Frm::WxButtonSaveDisFileClick(wxCommandEvent& event)
{
	// insert your code here
	intConstantHKValueFlag = new int[intNLAY];
	intConstantVKValueFlag = new int[intNLAY];
	intConstantSSValueFlag = new int[intNLAY];
	intConstantRechValueFlag = new int[intNPER];

	dblConstantHKValue = new double[intNLAY];
	dblConstantVKValue = new double[intNLAY];
	dblConstantSSValue = new double[intNLAY];
	dblConstantRechValue = new double[intNPER];

    //load layer bottoms from files

    long numLayers;
	long points_per_slice;
	long cols, rows;
	double xDistance;
	wxString dummy;

	numLayers=intNLAY;

	wxString wxFileName[numLayers];
	for(int j=0;j<numLayers;j++)
	{
        wxFileName[j]=WxListBoxNamesLayerBot->GetString(j);
	}

    getGRID sliceGRID;
//    sliceGRID.setFile(sliceFile[0]);
    sliceGRID.setFile(wxFileName[0]);
    sliceGRID.getPointsFromFile();
    sliceGRID.analyze_file_content();
    points_per_slice=sliceGRID.getNumberPoints();


    intPointsPerSlice=points_per_slice;
    dblXMin=sliceGRID.getXMin();
    dblYMin=sliceGRID.getYMin();



    double *pointZ_sl=new double[points_per_slice];

    double *pointZ_slice=new double[points_per_slice*(numLayers+1)];


    cols=sliceGRID.getNumberCols();
    rows=sliceGRID.getNumberRows();
    intNROW=rows;
    intNCOL=cols;
    xDistance=sliceGRID.getXDist();
    dblXDist=xDistance;
    dblYDist=xDistance;

    for (long counterSlices=0; counterSlices<numLayers;counterSlices++)
    {

//        sliceGRID.setFile(wxFileName[counterSlices]);
        sliceGRID.getPointsFromFile();
        sliceGRID.analyze_file_content();
        sliceGRID.getPoints(pointZ_sl);

        for(long i=0; i<points_per_slice;i++)
        {
            pointZ_slice[i+counterSlices*points_per_slice]=pointZ_sl[i];
        }
    }

    //set the variable for length units
    int intTempLengthUnits=0;
    intTempLengthUnits=WxChoiceLengthUnit->GetSelection();

    switch (intTempLengthUnits )
    {
        case 0: dblLENUNIMULT=1;
                wxMessageBox("Please set length units!");
                break;
        case 1: dblLENUNIMULT=0.348;
                break;
        case 2: dblLENUNIMULT=1;
                break;
        case 3: dblLENUNIMULT=0.1;
    }

    intLENUNI=2;


    //set the variable for time units
    int intTempTimeUnits;
    intTempTimeUnits=WxChoiceTimeUnits->GetSelection();

    switch (intTempTimeUnits )
    {
        case 0: dblTMUNIMULT=1;
                wxMessageBox("Please set time units!");
                break;
        case 1: dblTMUNIMULT=1;
                break;
        case 2: dblTMUNIMULT=60;
                break;
        case 3: dblTMUNIMULT=3600;
                break;
        case 4: dblTMUNIMULT=86400;
                break;
        case 5: dblTMUNIMULT=31536000;
    }

    intITMUNI=1;

    //set and calculate stress period parameters
    wxString wxstrPeriodLength;
    wxString *wxstrPeriodMode=new wxString[intNPER];
    long counter_token;
    double *dblPeriodLength=new double[intNPER];
    double *dblTimeStepLength=new double[intNPER];
    intNSTP=new long[intNPER];
    char *token;

    for(int j=0;j<intNPER;j++)
    {
      dblPeriodLength[j]=vStressPeriodLength[j];
      dblPeriodLength[j]=dblPeriodLength[j]*dblTMUNIMULT;

      dblTimeStepLength[j]=vTimeStepLength[j];
      dblTimeStepLength[j]=dblTimeStepLength[j]*dblTMUNIMULT;
      intNSTP[j]=(int)(dblPeriodLength[j]/dblTimeStepLength[j]);

      if(vTimeMode[j]==1){wxstrPeriodMode[j]="SS";}
      if(vTimeMode[j]==2){wxstrPeriodMode[j]="Tr";}

    }

    //Start output .dis-file
    wxString totalString;

    totalString<<intNLAY-1<<" ";
    totalString<<intNROW<<" ";
    totalString<<intNCOL<<" ";
    totalString<<intNPER<<" ";
    totalString<<intITMUNI<<" ";
    totalString<<intLENUNI<<"\n";


    for(int j=0;j<intNLAY-1;j++)
    {
        totalString<<"0 ";
    }

    totalString<<"\n";
    totalString<<"CONSTANT "<<dblXDist<<"\n";
    totalString<<"CONSTANT "<<dblYDist<<"\n";

    for (int counterLayer=0;counterLayer<intNLAY;counterLayer++)
    {
        totalString<<"INTERNAL 1.0 (FREE) 12\n";
        for (int counterRow=0;counterRow<intNROW;counterRow++)
        {
            for (int counterCol=0;counterCol<intNCOL;counterCol++)
            {
                int index=counterCol;
                index=index+counterRow*intNCOL;
                index=index+counterLayer*intNROW*intNCOL;
                totalString<<pointZ_slice[index]*dblLENUNIMULT<<" ";
            }
            totalString<<"\n";
        }
    }

    for (int counterPeriods=0;counterPeriods<intNPER;counterPeriods++)
    {
        totalString<<dblPeriodLength[counterPeriods]<<" "<<intNSTP[counterPeriods]<<" 1 "<<wxstrPeriodMode[counterPeriods]<<"\n";
    }



    wxString wxstrPathFileNameDis;
    wxstrPathFileNameDis<<pathProjectFilePre<<"/"<<wxstrProjName<<".dis";

    ofstream outFile(wxstrPathFileNameDis);//"D:\\grass_modflow\\grass_modflow\\testdata\\aaa.dis");
    outFile<<totalString;
    outFile.close();

    //End output .dis-file

    wxMessageBox("Modflow file exported");

}

/*
 * WxButtonClearBoundaryCondClick
 */
void gui2Frm::WxButtonClearBoundaryCondClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxBoundaryCond->Clear();
}

/*
 * WxButtonClearInitialHeadsClick
 */
void gui2Frm::WxButtonClearInitialHeadsClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxInitialHeads->Clear();
}

/*
 * WxButtonInsertBoundaryCondClick
 */
void gui2Frm::WxButtonInsertBoundaryCondClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxstrNumberLayersLabel;
	wxstrNumberLayersLabel<<intNLAY-1;
	WxStaticTextInfoNumLayersCount->SetLabel(wxstrNumberLayersLabel);

	wxString pathASCIIBoundaryGrid, tmpString;
	int boundaryCondGridOpenShow;
	boundaryCondGridOpenShow=WxOpenFileDialogBoundaryCond->ShowModal();
	pathASCIIBoundaryGrid=WxOpenFileDialogBoundaryCond->GetPath();
	WxListBoxBoundaryCond->AppendString(pathASCIIBoundaryGrid);
}

/*
 * WxButtonSaveBoundaryCondInitialHeadsClick
 */
void gui2Frm::WxButtonSaveBoundaryCondInitialHeadsClick(wxCommandEvent& event)
{
	// insert your code here
	long numLayers;
	long points_per_slice;
//	long cols, rows;
//	double xDistance;
	wxString dummy;

	numLayers=intNLAY-1;

	//Start reading boundary conditions files
	char *bcFile[numLayers+1];
	wxString wxBCFileName[numLayers];
	for(int j=0;j<numLayers;j++)
    {
        wxBCFileName[j]=WxListBoxBoundaryCond->GetString(j);
        const char *tempChar=wxBCFileName[j].mbc_str();
        bcFile[j]= (char*)tempChar;
    }
    getGRID bcGRID;
//    bcGRID.setFile(bcFile[0]);
    bcGRID.setFile(wxBCFileName[0]);
    bcGRID.getPointsFromFile();
    bcGRID.analyze_file_content();
    points_per_slice=bcGRID.getNumberPoints();
    intPointsPerSlice=points_per_slice;

    double *pointBC_sl=new double[points_per_slice];

    double *pointBC_slice=new double[points_per_slice*(numLayers+1)];


    for (long counterSlices=0; counterSlices<numLayers;counterSlices++)
    {

//        bcGRID.setFile(bcFile[counterSlices]);
	bcGRID.setFile(wxBCFileName[counterSlices]);
        bcGRID.getPointsFromFile();
        bcGRID.analyze_file_content();
        bcGRID.getPoints(pointBC_sl);

        for(long i=0; i<points_per_slice;i++)
        {
            pointBC_slice[i+counterSlices*points_per_slice]=pointBC_sl[i];
        }
    }
    //End reading boundary conditions files

    //Start reading initial heads files
    char *ihFile[numLayers+1];
	wxString wxIHFileName[numLayers];
	for(int j=0;j<numLayers;j++)
    {
        wxIHFileName[j]=WxListBoxInitialHeads->GetString(j);
        const char *tempChar=wxIHFileName[j].mbc_str();
        ihFile[j]= (char*)tempChar;
    }
    getGRID initialsGRID;
//    initialsGRID.setFile(ihFile[0]);
    initialsGRID.setFile(wxIHFileName[0]);
    initialsGRID.getPointsFromFile();
    initialsGRID.analyze_file_content();
    points_per_slice=initialsGRID.getNumberPoints();

    double *pointInitials_sl=new double[points_per_slice];

    double *pointInitials_slice=new double[points_per_slice*(numLayers+1)];


    for (long counterSlices=0; counterSlices<numLayers;counterSlices++)
    {

//        initialsGRID.setFile(ihFile[counterSlices]);
	initialsGRID.setFile(wxIHFileName[counterSlices]);
        initialsGRID.getPointsFromFile();
        initialsGRID.analyze_file_content();
        initialsGRID.getPoints(pointInitials_sl);

        for(long i=0; i<points_per_slice;i++)
        {
            pointInitials_slice[i+counterSlices*points_per_slice]=pointInitials_sl[i];
        }
    }
    //End reading initial head files

    //Start output .ba6 file
    wxString totalba6String;

    totalba6String<<"FREE\n";

    for (int counterLayer=0;counterLayer<intNLAY-1;counterLayer++)
    {
        totalba6String<<"INTERNAL 1 (FREE) 5 \n";
        for (int counterRow=0;counterRow<intNROW;counterRow++)
        {
            for (int counterCol=0;counterCol<intNCOL;counterCol++)
            {
                int index=counterCol;
                index=index+counterRow*intNCOL;
                index=index+counterLayer*intNROW*intNCOL;
                totalba6String<<pointBC_slice[index]<<" ";
            }
            totalba6String<<"\n";
        }
    }

    totalba6String<<"-9999\n";

    for (int counterLayer=0;counterLayer<intNLAY-1;counterLayer++)
    {
        totalba6String<<"INTERNAL 1.0 (FREE) 12\n";
        for (int counterRow=0;counterRow<intNROW;counterRow++)
        {
            for (int counterCol=0;counterCol<intNCOL;counterCol++)
            {
                int index=counterCol;
                index=index+counterRow*intNCOL;
                index=index+counterLayer*intNROW*intNCOL;
                totalba6String<<pointInitials_slice[index]<<" ";
            }
            totalba6String<<"\n";
        }
    }

    wxString wxstrPathFileNameBa6;
    wxFile wxFileBa6;
    wxstrPathFileNameBa6<<pathProjectFilePre<<"/"<<wxstrProjName<<".ba6";

    wxFileBa6.Open(wxstrPathFileNameBa6,wxFile::write, wxS_DEFAULT);
    wxFileBa6.Write(totalba6String, wxConvUTF8);
    wxFileBa6.Close();

    ofstream outFile(wxstrPathFileNameBa6);//"D:\\grass_modflow\\grass_modflow\\testdata\\aaa.ba6");
    outFile<<totalba6String;
    outFile.close();
    //End output .ba6 file

    wxMessageBox("Modflow file exported");

}

/*
 * WxButtonInsertInitialHeadsClick
 */
void gui2Frm::WxButtonInsertInitialHeadsClick(wxCommandEvent& event)
{
	// insert your code here

	wxString pathASCIIInitialHeads, tmpString;
	int initialHeadsGridOpenShow;
	initialHeadsGridOpenShow=WxOpenFileDialogInitialHeads->ShowModal();
	pathASCIIInitialHeads=WxOpenFileDialogInitialHeads->GetPath();
	WxListBoxInitialHeads->AppendString(pathASCIIInitialHeads);
}

/*
 * WxButtonInsertHorConductClick
 */
void gui2Frm::WxButtonInsertHorConductClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxstrHorKDistriPath, wxstrHorKConstant, wxstrLayerTypeLB, tempString, wxstrNumberLayersLabel;
	int intHorKConstantChecked, intHorKOpenShow;
	long intLayerCounter;
	double dblTemp;
	wxstrNumberLayersLabel<<intNLAY-1;
	WxStaticTextParamInfoNumLayers->SetLabel(wxstrNumberLayersLabel);



//		wxString pathASCIIBottomGrid, tmpString;
//	int bottomGridOpenShow, numberLayers;
//	bottomGridOpenShow=WxOpenFileDialogBottoms->ShowModal();
//	pathASCIIBottomGrid=WxOpenFileDialogBottoms->GetPath();


    paramSetting *hksetting=new paramSetting(NULL);
    hksetting->setLayerType(0);
    cout<<"1"<<endl;
    hksetting->setTextValue(1);
    cout<<"2"<<endl;
    intHorKOpenShow=hksetting->ShowModal();
    cout<<"3"<<endl;
    intHorKConstantChecked=hksetting->getConstantValueChecked();
    cout<<"4"<<endl;
    wxstrHorKConstant=hksetting->getConstantValue();
    cout<<"5"<<endl;

    if (intHorKConstantChecked>0)
    {
        tempString<<"CONSTANT "<<wxstrHorKConstant;
        intLayerCounter=WxListBoxHorConduct->GetCount();
        intConstantHKValueFlag[intLayerCounter]=1;
        if(!wxstrHorKConstant.ToDouble(&dblTemp)){ /* error! */ }
        dblConstantHKValue[intLayerCounter]=dblTemp;
    }
    else
    {
        wxstrHorKDistriPath=hksetting->getParamFilePath();
        tempString=wxstrHorKDistriPath;
        intLayerCounter=WxListBoxHorConduct->GetCount();
        intConstantHKValueFlag[intLayerCounter]=-1;
    }

    wxstrLayerTypeLB=hksetting->getLayerType();
    wxstrLayerTypeLB<<0;
    wxstrLayerType<<wxstrLayerTypeLB<<" ";
    WxListBoxHorConduct->AppendString(tempString);

//    wxString pathASCIIBottomGrid, tmpString;
//	int bottomGridOpenShow, numberLayers;
//	bottomGridOpenShow=WxOpenFileDialogBottoms->ShowModal();
//	pathASCIIBottomGrid=WxOpenFileDialogBottoms->GetPath();
//	WxListBoxNamesLayerBot->AppendString(pathASCIIBottomGrid);


}

/*
 * WxButtonInsertVertConductClick
 */
void gui2Frm::WxButtonInsertVertConductClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxstrVertKDistriPath, wxstrVertKConstant, tempString;
	int intVertKConstantChecked;
    long intLayerCounter;
    double dblTemp;

    paramSetting *vksetting=new paramSetting(NULL);
    vksetting->setLayerType(1);
    vksetting->setTextValue(1);
    vksetting->ShowModal();
    intVertKConstantChecked=vksetting->getConstantValueChecked();
    wxstrVertKConstant=vksetting->getConstantValue();

    if (intVertKConstantChecked>0)
    {
        tempString<<"CONSTANT "<<wxstrVertKConstant;
        intLayerCounter=WxListBoxVertConduct->GetCount();
        intConstantVKValueFlag[intLayerCounter]=1;
        if(!wxstrVertKConstant.ToDouble(&dblTemp)){ /* error! */ }
        dblConstantVKValue[intLayerCounter]=dblTemp;
    }
    else
    {
        wxstrVertKDistriPath=vksetting->getParamFilePath();
        tempString=wxstrVertKDistriPath;
        intLayerCounter=WxListBoxVertConduct->GetCount();
        intConstantVKValueFlag[intLayerCounter]=-1;
    }
    WxListBoxVertConduct->AppendString(tempString);
}

/*
 * WxButtonInsertSpecStorageClick
 */
void gui2Frm::WxButtonInsertSpecStorageClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxstrSsDistriPath, wxstrSsConstant, tempString;
	int intSsConstantChecked;
    long intLayerCounter;
    double dblTemp;

    paramSetting *sssetting=new paramSetting(NULL);
    sssetting->setLayerType(1);
    sssetting->setTextValue(1);
    sssetting->ShowModal();
    intSsConstantChecked=sssetting->getConstantValueChecked();
    wxstrSsConstant=sssetting->getConstantValue();

    if (intSsConstantChecked>0)
    {
        tempString<<"CONSTANT "<<wxstrSsConstant;
        intLayerCounter=WxListBoxSpecStorage->GetCount();
        intConstantSSValueFlag[intLayerCounter]=1;
        if(!wxstrSsConstant.ToDouble(&dblTemp)){ /* error! */ }
        dblConstantSSValue[intLayerCounter]=dblTemp;
    }
    else
    {
        wxstrSsDistriPath=sssetting->getParamFilePath();
        tempString=wxstrSsDistriPath;
        intLayerCounter=WxListBoxSpecStorage->GetCount();
        intConstantSSValueFlag[intLayerCounter]=-1;
    }
    WxListBoxSpecStorage->AppendString(tempString);
}

/*
 * WxButtonDelHorConductClick
 */
void gui2Frm::WxButtonDelHorConductClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxHorConduct->Clear();
}

/*
 * WxButtonDelVertConductClick
 */
void gui2Frm::WxButtonDelVertConductClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxVertConduct->Clear();
}


/*
 * WxButtonDelSpecStorageClick
 */
void gui2Frm::WxButtonDelSpecStorageClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxSpecStorage->Clear();
}

/*
 * WxButtonSaveParametersModflowClick
 */
void gui2Frm::WxButtonSaveParametersModflowClick(wxCommandEvent& event)
{
	// insert your code here

    long numLayers;
    long points_per_slice;

    numLayers=intNLAY-1;
    points_per_slice=intPointsPerSlice;

    //Start reading horizontal conductivity files
    char *horKFile;
    wxString wxHorKFileName, TempString;

    double *pointHK_sl=new double[points_per_slice];
    double *pointHK_slice=new double[points_per_slice*(numLayers+1)];

    for (long intCounterSlice=0;intCounterSlice<numLayers;intCounterSlice++)
    {

        if (intConstantHKValueFlag[intCounterSlice]>0)
        {
            pointHK_slice[intCounterSlice*points_per_slice+1]=dblConstantHKValue[intCounterSlice];
        }
        else
        {
            wxHorKFileName=WxListBoxHorConduct->GetString(intCounterSlice);
            getGRID horKGRID;
	    horKGRID.setFile(wxHorKFileName);
            horKGRID.getPointsFromFile();
            horKGRID.analyze_file_content();
            horKGRID.getPoints(pointHK_sl);

            for(long i=0; i<points_per_slice;i++)
            {
                pointHK_slice[i+intCounterSlice*points_per_slice]=pointHK_sl[i];
            }
        }
    }

    //End reading horizontal conductivity files

    //Start reading vertical conductivity files

	char *vertKFile;
	wxString wxVertKFileName;

	double *pointVK_sl=new double[points_per_slice];
    double *pointVK_slice=new double[points_per_slice*(numLayers+1)];

	for(long intCounterSlice=0;intCounterSlice<numLayers;intCounterSlice++)
    {
        if (intConstantVKValueFlag[intCounterSlice]>0)
        {
            pointVK_slice[intCounterSlice*points_per_slice+1]=dblConstantVKValue[intCounterSlice];
        }
        else
        {
            wxVertKFileName=WxListBoxVertConduct->GetString(intCounterSlice);
            const char *tempChar=wxVertKFileName.mbc_str();
            vertKFile= (char*)tempChar;

            getGRID vertKGRID;
//            vertKGRID.setFile(vertKFile);
	    vertKGRID.setFile(wxVertKFileName);
            vertKGRID.getPointsFromFile();
            vertKGRID.analyze_file_content();
            vertKGRID.getPoints(pointVK_sl);

            for(long i=0; i<points_per_slice;i++)
            {
                pointVK_slice[i+intCounterSlice*points_per_slice]=pointVK_sl[i];
            }
        }
    }
    //End reading vertical conductivity files

    //Start reading specific storage file
    char *specStorFile;
	wxString wxSpecStorFileName;

	double *pointSS_sl=new double[points_per_slice];
    double *pointSS_slice=new double[points_per_slice*(numLayers+1)];

	for(long intCounterSlice=0;intCounterSlice<numLayers;intCounterSlice++)
    {
        if (intConstantSSValueFlag[intCounterSlice]>0)
        {
            pointSS_slice[intCounterSlice*points_per_slice+1]=dblConstantSSValue[intCounterSlice];
        }
        else
        {
            wxSpecStorFileName=WxListBoxSpecStorage->GetString(intCounterSlice);
            const char *tempChar=wxSpecStorFileName.mbc_str();
            specStorFile= (char*)tempChar;

            getGRID specStorGRID;
//            specStorGRID.setFile(specStorFile);
	    specStorGRID.setFile(wxSpecStorFileName);
            specStorGRID.getPointsFromFile();
            specStorGRID.analyze_file_content();
            specStorGRID.getPoints(pointSS_sl);

            for(long i=0; i<points_per_slice;i++)
            {
                pointSS_slice[i+intCounterSlice*points_per_slice]=pointSS_sl[i];
            }
        }

    }

    //End reading specific storage file

    //Start writing .lpf file

    wxString wxstrVerticalKTemp=wxstrVerticalK;
    wxstrVerticalK="";
    wxString wxstrLayerAverageTemp=wxstrLayerAverage;
    wxstrLayerAverage="";

    for (long counterSlices=0; counterSlices<numLayers;counterSlices++)
    {
//        wxstrLayerType<<"0 ";
        wxstrLayerAverage<<wxstrLayerAverageTemp<<" ";
        wxstrChani<<"1.0 ";
        wxstrVerticalK<<wxstrVerticalKTemp<<" ";
        wxstrWetting<<"0 ";
    }


    wxString totalLPFString;

    totalLPFString<<"0 -2.000000000000E+020 0 ; ILPFCB, HDRY, NPLPF\n";                  //ILPFCB, HDRY, NPLPF
    totalLPFString<<wxstrLayerType<<" ; LAYTYP(NLAY)\n";       //Layer type confined or convertible
    totalLPFString<<wxstrLayerAverage<<" ; LAYAVG(NLAY)\n";    //Averaging method
    totalLPFString<<wxstrChani<<"  ; CHANI(NLAY)\n";           //Horizontal anisotropy (1=no anisotropy)
    totalLPFString<<wxstrVerticalK<<" ; LAYVKA(NLAY)\n";       //Vertical layer definition (0=vert. values, 1=ratios hor/vert
    totalLPFString<<wxstrWetting<<" ; LAYWET(NLAY)\n";         //Wetting is inactive


    for (int counterLayer=0;counterLayer<intNLAY-1;counterLayer++)
    {
        //Start writing horizontal conductivities
        if (intConstantHKValueFlag[counterLayer]>0)
        {
            totalLPFString<<"CONSTANT "<<pointHK_slice[counterLayer*points_per_slice+1]<<"\n";
        }
        else
        {
            totalLPFString<<"INTERNAL 1.0 (FREE) 12\n";
            for (long counterRow=0;counterRow<intNROW;counterRow++)
            {
                for (long counterCol=0;counterCol<intNCOL;counterCol++)
                {
                    int index=counterCol;
                    index=index+counterRow*intNCOL;
                    index=index+counterLayer*intNROW*intNCOL;
                    totalLPFString<<pointHK_slice[index]<<" ";
                }
                totalLPFString<<"\n";
            }
        }
        //End writing horizontal conductivities

        //Start writing vertical conductivities
        if (intConstantVKValueFlag[counterLayer]>0)
        {
            totalLPFString<<"CONSTANT "<<pointVK_slice[counterLayer*points_per_slice+1]<<"\n";
        }
        else
        {
            totalLPFString<<"INTERNAL 1.0 (FREE)\n";
            for (int counterRow=0;counterRow<intNROW;counterRow++)
            {
                for (int counterCol=0;counterCol<intNCOL;counterCol++)
                {
                    int index=counterCol;
                    index=index+counterRow*intNCOL;
                    index=index+counterLayer*intNROW*intNCOL;
                    totalLPFString<<pointVK_slice[index]<<" ";
                }
                totalLPFString<<"\n";
            }
        }
        //End writing vertical conductivities

        //Start writing specific storage
        if (intConstantSSValueFlag[counterLayer]>0)
        {
            totalLPFString<<"CONSTANT "<<pointSS_slice[counterLayer*points_per_slice+1]<<"\n";
        }
        else
        {
            totalLPFString<<"INTERNAL 1.0 (FREE)\n";
            for (int counterRow=0;counterRow<intNROW;counterRow++)
            {
                for (int counterCol=0;counterCol<intNCOL;counterCol++)
                {
                    int index=counterCol;
                    index=index+counterRow*intNCOL;
                    index=index+counterLayer*intNROW*intNCOL;
                    totalLPFString<<pointSS_slice[index]<<" ";
                }
                totalLPFString<<"\n";
            }
        }
        //End writing specific storage

    }

    wxString wxstrPathFileNameLpf;
    wxstrPathFileNameLpf<<pathProjectFilePre<<"/"<<wxstrProjName<<".lpf";
    ofstream outFile(wxstrPathFileNameLpf);//"D:\\grass_modflow\\grass_modflow\\testdata\\aaa.lpf");
    outFile<<totalLPFString;
    outFile.close();

    //End writing .lpf file
    wxMessageBox("Modflow file exported");

}

/*
 * WxRadioButtonAverArithLogClick
 */
void gui2Frm::WxRadioButtonAverArithLogClick(wxCommandEvent& event)
{
	// insert your code here
	wxstrLayerAverage="2";
}

/*
 * WxRadioButtonAverLogClick
 */
void gui2Frm::WxRadioButtonAverLogClick(wxCommandEvent& event)
{
	// insert your code here
	wxstrLayerAverage="1";
}

/*
 * WxRadioButtonHarmonicMeanClick
 */
void gui2Frm::WxRadioButtonHarmonicMeanClick(wxCommandEvent& event)
{
	// insert your code here
	wxstrLayerAverage="0";
}

/*
 * WxRadioButtonVertValuesClick
 */
void gui2Frm::WxRadioButtonVertValuesClick(wxCommandEvent& event)
{
	// insert your code here
	wxstrVerticalK="0";
}

/*
 * WxRadioButtonRatioHVClick
 */
void gui2Frm::WxRadioButtonRatioHVClick(wxCommandEvent& event)
{
	// insert your code here
	wxstrVerticalK="1";
}

/*
 * WxButtonRechInsertClick
 */
void gui2Frm::WxButtonRechInsertClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxstrNumStressPeriods;
	wxstrNumStressPeriods<<intNPER;
	WxStaticTextRechWellNUmStressPeriods->SetLabel(wxstrNumStressPeriods);

	wxString wxstrRechDistriPath, wxstrRechConstant, tempString;
	int intRechConstantChecked;
    long intStressPerCounter;
    double dblTemp;

    paramSetting *rechsetting=new paramSetting(NULL);
    rechsetting->setLayerType(1);
    rechsetting->setTextValue(-1);
    rechsetting->ShowModal();
    intRechConstantChecked=rechsetting->getConstantValueChecked();
    wxstrRechConstant=rechsetting->getConstantValue();

    if (intRechConstantChecked>0)
    {
        tempString<<"CONSTANT "<<wxstrRechConstant;
        intStressPerCounter=WxListBoxRech->GetCount();
        intConstantRechValueFlag[intStressPerCounter]=1;
        if(!wxstrRechConstant.ToDouble(&dblTemp)){ /* error! */ }
        dblConstantRechValue[intStressPerCounter]=dblTemp;
    }
    else
    {
        wxstrRechDistriPath=rechsetting->getParamFilePath();
        tempString=wxstrRechDistriPath;
        intStressPerCounter=WxListBoxRech->GetCount();
        intConstantRechValueFlag[intStressPerCounter]=-1;
    }
    WxListBoxRech->AppendString(tempString);

}

/*
 * WxButtonRechClearClick
 */
void gui2Frm::WxButtonRechClearClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxRech->Clear();
}

/*
 * WxButtonWellsInsertClick
 */
void gui2Frm::WxButtonWellsInsertClick(wxCommandEvent& event)
{
	// insert your code here
	wxString pathASCIIWellFile, tmpString;
	int wellFileOpenShow;
	wellFileOpenShow=WxOpenFileDialogBottoms->ShowModal();
	pathASCIIWellFile=WxOpenFileDialogBottoms->GetPath();
	WxListBoxWells->AppendString(pathASCIIWellFile);
}

/*
 * WxButtonWellsDeleteClick
 */
void gui2Frm::WxButtonWellsDeleteClick(wxCommandEvent& event)
{
	// insert your code here
	WxListBoxWells->Clear();
}

/*
 * Mnunewproject1119Click
 */
void gui2Frm::Mnunewproject1119Click(wxCommandEvent& event)
{
	// insert your code here
	wxFileName projDir;
	bool projBool;
	int projectFileOpenShow;
	projectFileOpenShow=WxOpenFileDialogBottoms->ShowModal();
	pathProjectFile=WxOpenFileDialogBottoms->GetPath();
	wxstrProjName=WxOpenFileDialogBottoms->GetFilename();
	projDir.Mkdir(pathProjectFile, 0);
	pathProjectFilePre<<pathProjectFile<<"/mf_pre";
	pathProjectFilePost<<pathProjectFile<<"/mf_post";
	pathProjectFileEx<<pathProjectFile<<"/exchange";
	projDir.Mkdir(pathProjectFilePre, 0);
	projDir.Mkdir(pathProjectFilePost, 0);
	projDir.Mkdir(pathProjectFileEx, 0);
}

/*
 * WxButtonRechWellsSaveModflowClick
 */
void gui2Frm::WxButtonRechWellsSaveModflowClick(wxCommandEvent& event)
{
	// insert your code here
	//Recharge calculation and export as .rch file
	wxString totalRCHString;
 	int intTempRechUnits;
    intTempRechUnits=WxChoiceRechUnits->GetSelection();

    switch (intTempRechUnits)
    {
        case 0: dblRechargeMult=3.171e-11;
                break;
        case 1: dblRechargeMult=1.1574e-7;
                break;
        case 2: dblRechargeMult=1.1574e-8;
                break;
        case 3: dblRechargeMult=1;
                break;
        case 4: dblRechargeMult=1.1574e-5;
    }

    long numStressPeriods;
    long points_per_slice;

    numStressPeriods=intNPER;
    points_per_slice=intPointsPerSlice;

    //Start reading recharge files
    char *rechFile;
    wxString wxRechFileName, TempString;

    double *pointRech_sl=new double[points_per_slice];
    double *pointRech_slice=new double[points_per_slice*(numStressPeriods+1)];

    for (long intCounterPeriod=0;intCounterPeriod<numStressPeriods;intCounterPeriod++)
    {

        if (intConstantRechValueFlag[intCounterPeriod]>0)
        {
            pointRech_slice[intCounterPeriod*points_per_slice+1]=dblConstantRechValue[intCounterPeriod]*dblRechargeMult;
        }
        else
        {
            wxRechFileName=WxListBoxRech->GetString(intCounterPeriod);
            const char *tempChar=wxRechFileName.mbc_str();
            rechFile= (char*)tempChar;

            getGRID rechGRID;
//            rechGRID.setFile(rechFile);
	    rechGRID.setFile(wxRechFileName);
            rechGRID.getPointsFromFile();
            rechGRID.analyze_file_content();
            rechGRID.getPoints(pointRech_sl);

            for(long i=0; i<points_per_slice;i++)
            {
                pointRech_slice[i+intCounterPeriod*points_per_slice]=pointRech_sl[i]*dblRechargeMult;
            }
        }
    }
    //End reading horizontal conductivity files


    //Start writing recharge data to string
    totalRCHString<<"3 0\n";

    for (int counterStressPeriods=0;counterStressPeriods<intNPER;counterStressPeriods++)
    {
        //Start writing horizontal conductivities
        totalRCHString<<"0 0\n";
        if (intConstantRechValueFlag[counterStressPeriods]>0)
        {
            totalRCHString<<"CONSTANT "<<pointRech_slice[counterStressPeriods*points_per_slice+1]<<"\n";
        }
        else
        {
            totalRCHString<<"INTERNAL 1.0 (FREE)\n";
            for (long counterRow=0;counterRow<intNROW;counterRow++)
            {
                for (long counterCol=0;counterCol<intNCOL;counterCol++)
                {
                    int index=counterCol;
                    index=index+counterRow*intNCOL;
                    index=index+counterStressPeriods*intNROW*intNCOL;
                    totalRCHString<<pointRech_slice[index]<<" ";
                }
                totalRCHString<<"\n";
            }
        }
    }
    //End writing recharge data to string

    //Start writing recharge data to file
    wxString wxstrPathFileNameRch;
    wxstrPathFileNameRch<<pathProjectFilePre<<"/"<<wxstrProjName<<".rch";
    ofstream outFile1(wxstrPathFileNameRch);
    outFile1<<totalRCHString;
    outFile1.close();

    //End writing recharge data to file


    //Start processing well data
 	int intTempDischargeUnits;
    intTempDischargeUnits=WxChoiceDischargUnits->GetSelection();

    switch (intTempDischargeUnits)
    {
        case 0:dblDischargeMult=1.1574e-5;
                break;
        case 1:dblDischargeMult=3.171e-8;
                break;
        case 2:dblDischargeMult=1;
                break;
        case 3:dblDischargeMult=1.1574e-8;
                break;
        case 4:dblDischargeMult=3.171e-11;
                break;
        case 5:dblDischargeMult=0.001;
                break;
    }

    //Start reading well files
    char *wellFile;
    wxString wxWellFileName;
    long *lngNumberWells=new long[numStressPeriods];
    long lngMaxNumWells=0;

    for (long intCounterPeriod=0;intCounterPeriod<numStressPeriods;intCounterPeriod++)
    {
            wellFile="";
            wxWellFileName=WxListBoxWells->GetString(intCounterPeriod);
            const char *tempChar2=wxWellFileName.mbc_str();
            wellFile=(char*)tempChar2;
            getWellData wellData;
            wellData.setFile(wellFile);
            wellData.getPointsFromFile();
            wellData.analyze_file_content();
            lngNumberWells[intCounterPeriod]=wellData.getNumberWells();
            if (lngNumberWells[intCounterPeriod]>lngMaxNumWells) {lngMaxNumWells=lngNumberWells[intCounterPeriod];}
            else {lngMaxNumWells=lngMaxNumWells;}
    }


    double *tempWellX=new double[lngMaxNumWells];
    double *tempWellY=new double[lngMaxNumWells];
    double *tempWellLayer=new double[lngMaxNumWells];
    double *tempWellDischarge=new double[lngMaxNumWells];

    wxString totalWellString;
    totalWellString<<lngMaxNumWells<<" 0\n";

    double dblTempX;
    double dblTempY;
    long lngTempCellX;
    long lngTempCellY;
    long lngTempLayer;
    double dblTempDischarge;

    //wxMessageBox(totalWellString);

    for (long intCounterPeriod=0;intCounterPeriod<numStressPeriods;intCounterPeriod++)
    {
            totalWellString<<lngNumberWells[intCounterPeriod]<<" 0\n";
            getWellData wellData;
            wellData.setFile(wellFile);
            wellData.getPointsFromFile();
            wellData.analyze_file_content();
            wellData.getPoints(tempWellX, tempWellY, tempWellLayer, tempWellDischarge);

            for (long intCounterWells=0;intCounterWells<lngNumberWells[intCounterPeriod];intCounterWells++)
            {
                dblTempX=tempWellX[intCounterWells];
                dblTempY=tempWellY[intCounterWells];
                lngTempCellX=(int((dblTempX-dblXMin)/dblXDist)+1);
                lngTempCellY=intNROW-(int((dblTempY-dblYMin)/dblYDist)+1);
                lngTempLayer=int (tempWellLayer[intCounterWells]);
                dblTempDischarge=tempWellDischarge[intCounterWells]*dblDischargeMult;
                totalWellString<<lngTempLayer<<" "<<lngTempCellY<<" "<<lngTempCellX<<" "<<dblTempDischarge<<"\n";
            }
            //wxMessageBox(totalWellString);
    }
    //End reading well files

    //Start writing well file
    wxString wxstrPathFileNameWel;
    wxstrPathFileNameWel<<pathProjectFilePre<<"/"<<wxstrProjName<<".wel";
    ofstream outFile2(wxstrPathFileNameWel);
    outFile2<<totalWellString;
    outFile2.close();
    //End writing well file

    wxMessageBox("MODFLOW file exported");
}



/*
 * WxButtonSaveRunModflowClick
 */
void gui2Frm::WxButtonSaveRunModflowClick(wxCommandEvent& event)
{
	// insert your code here
	//Start exporting PCG file
	long lngOuterIterations, lngInnerIteration, lngNPCOND, lngRelax, lngNBPOL, lngPrintPCGRes, lngPrintParamPCG;
	double dblHeadChange, dblResCrit, dblDamp;
	wxString wxstrTempString;
	wxString wxstrTotalPCGString;

	lngNPCOND=1;
    lngRelax=1;
	lngNBPOL=1;
	lngPrintPCGRes=1;
	lngPrintParamPCG=2;
	dblDamp=1.0;

	wxstrTempString=WxEditOuterIter->GetValue();
	if(!wxstrTempString.ToLong(&lngOuterIterations)){ /* error! */ }

	wxstrTotalPCGString<<wxstrTempString<<" ";

    wxstrTempString=WxEditInnerIterations->GetValue();
	if(!wxstrTempString.ToLong(&lngInnerIteration)){ /* error! */ }

	wxstrTotalPCGString<<wxstrTempString<<" ";

	wxstrTotalPCGString<<" 1\n";

	wxstrTempString=WxEditHeadChangeCrit->GetValue();
	if(!wxstrTempString.ToDouble(&dblHeadChange)){ /* error! */ }

	wxstrTotalPCGString<<wxstrTempString<<" ";

	wxstrTempString=WxEditResidualCrit->GetValue();
	if(!wxstrTempString.ToDouble(&dblResCrit)){ /* error! */ }

	wxstrTotalPCGString<<wxstrTempString<<" ";

	wxstrTotalPCGString<<lngRelax<<" "<<lngNBPOL<<" "<<lngPrintPCGRes<<" "<<lngPrintParamPCG<<" "<<dblDamp<<"\n";

	wxString wxstrPathFileNamePCG;
    wxstrPathFileNamePCG<<pathProjectFilePre<<"/"<<wxstrProjName<<".pcg";
    ofstream outFile1(wxstrPathFileNamePCG);//"D:\\grass_modflow\\grass_modflow\\testdata\\aaa.pcg");
    outFile1<<wxstrTotalPCGString;
    outFile1.close();

	//End exporting PCG file

	//Start exporting NAM file
	wxString wxstrNamString;

	wxstrNamString<<"LIST 1 "<<pathProjectFilePost<<"/"<<wxstrProjName<<".lst\n";
	wxstrNamString<<"BAS6 2 "<<pathProjectFilePre<<"/"<<wxstrProjName<<".ba6\n";
	wxstrNamString<<"DIS 9 "<<pathProjectFilePre<<"/"<<wxstrProjName<<".dis\n";
	wxstrNamString<<"LPF 7 "<<pathProjectFilePre<<"/"<<wxstrProjName<<".lpf\n";
	wxstrNamString<<"RCH 10 "<<pathProjectFilePre<<"/"<<wxstrProjName<<".rch\n";
	wxstrNamString<<"WEL 12 "<<pathProjectFilePre<<"/"<<wxstrProjName<<".wel\n";
	wxstrNamString<<"PCG 15 "<<pathProjectFilePre<<"/"<<wxstrProjName<<".pcg\n";
	wxstrNamString<<"OC 33 "<<pathProjectFilePre<<"/"<<wxstrProjName<<".oc\n";

	wxString wxstrPathFileNameNAM;
    wxstrPathFileNameNAM<<pathProjectFilePre<<"/"<<wxstrProjName<<".nam";
    ofstream outFile2(wxstrPathFileNameNAM);
    outFile2<<wxstrNamString;
    outFile2.close();

    wxString wxstrCallMODFLOW;
    wxstrCallMODFLOW<<"mf2005 "<<pathProjectFilePre<<"/"<<wxstrProjName;
    system(wxstrCallMODFLOW);

	//End exporting NAM file
}

/*
 * WxButtonSaveOutputControlClick
 */
void gui2Frm::WxButtonSaveOutputControlClick(wxCommandEvent& event)
{
	// insert your code here
	//Compose string for periods


	long intNumberSavePeriods;

	wxString *wxstrSavePeriods;

	wxString wxstrTempA;


	if (!WxCheckBoxSaveResAllStressPeriods->GetValue())
	{

        intNumberSavePeriods=WxListBoxSaveResStressPeriods->GetCount();
        intSAVEPERIODS=intNumberSavePeriods;
        wxstrSavePeriods=new wxString[intNumberSavePeriods];

        for (long intCounterPeriods=0;intCounterPeriods<intNumberSavePeriods;intCounterPeriods++)
        {
            long intTempPeriodNumber;
            wxString wxstrTempPer;
            wxstrTempPer=WxListBoxSaveResStressPeriods->GetString(intCounterPeriods);
            if(!wxstrTempPer.ToLong(&intTempPeriodNumber)){ /* error! */ };
            wxstrSavePeriods[intCounterPeriods]<<"PERIOD "<<wxstrTempPer<<" STEP "<<intNSTP[intTempPeriodNumber-1]-1;
        }
    }

    else
    {
        wxstrSavePeriods=new wxString[intNPER];

        intSAVEPERIODS=intNPER;

        for(long intCounterPeriods=0;intCounterPeriods<intNPER;intCounterPeriods++)
        {
            wxstrSavePeriods[intCounterPeriods]<<"PERIOD "<<intCounterPeriods+1<<" STEP "<<intNSTP[intCounterPeriods]-1;
        }
    }

    //End compose string for all periods

    //Compose string for layers

    long intNumberSaveLayers;

    wxString wxstrSaveLayers;

    wxstrSaveLayers<<"SAVE HEAD ";

    if (!WxCheckBoxSaveResAllLayers->GetValue())
	{
        intNumberSaveLayers=WxListBoxSaveResLayers->GetCount();

        for (long intCounterLayers=0;intCounterLayers<intNumberSaveLayers;intCounterLayers++)
        {
            wxString wxstrTempLay;
            wxstrTempLay=WxListBoxSaveResLayers->GetString(intCounterLayers);
            wxstrSaveLayers<<wxstrTempLay<<" ";
        }
    }

    else
    {
        for(long intCounterLayers=0;intCounterLayers<intNLAY-1;intCounterLayers++)
        {
            wxstrSaveLayers<<intCounterLayers+1<<" ";
        }
    }

    //End compose string for each layer

    //Compose total string for .oc file

    wxString wxstrOC;

    wxstrOC<<"HEAD SAVE FORMAT (10G11.4)\n";
    wxstrOC<<"HEAD SAVE UNIT 45\n";

    for (long intCounterPeriods=0;intCounterPeriods<intSAVEPERIODS;intCounterPeriods++)
    {
        wxstrOC<<wxstrSavePeriods[intCounterPeriods]<<"\n";
        wxstrOC<<wxstrSaveLayers<<"\n";
    }
    //End compose total string for .oc file

    //Start exporting .oc file
    wxString wxstrPathFileNameOC;
    wxstrPathFileNameOC<<pathProjectFilePre<<"/"<<wxstrProjName<<".oc";
    ofstream outFile(wxstrPathFileNameOC);
    outFile<<wxstrOC;
    outFile.close();
    //End exporting .oc file

    wxMessageBox("MODFLOW file exported");

}

/*
 * WxCheckBoxSaveResAllStressPeriodsClick
 */
void gui2Frm::WxCheckBoxSaveResAllStressPeriodsClick(wxCommandEvent& event)
{
	// insert your code here
	intSaveAllPeriods=2;
}

/*
 * WxCheckBoxSaveResAllLayersClick
 */
void gui2Frm::WxCheckBoxSaveResAllLayersClick(wxCommandEvent& event)
{
	// insert your code here
	intSaveAllLayers=2;
}

/*
 * WxListBoxSaveResStressPeriodsSelected
 */
void gui2Frm::WxListBoxSaveResStressPeriodsSelected(wxCommandEvent& event)
{
	// insert your code here
	intSaveAllPeriods=0;
}

/*
 * WxListBoxSaveResLayersSelected
 */
void gui2Frm::WxListBoxSaveResLayersSelected(wxCommandEvent& event)
{
	// insert your code here
	intSaveAllLayers=0;
}

/*
 * WxButtonAddSavePeriodClick
 */
void gui2Frm::WxButtonAddSavePeriodClick(wxCommandEvent& event)
{
	// insert your code here

	wxArrayString strings;
	wxArrayString stringsRes;
	wxString wxstrTempAddSavePL;
	wxArrayInt wxarrintChosenPeriods;

	for(long intCounterPer=0;intCounterPer<intNPER;intCounterPer++)
	{
        wxstrTempAddSavePL="";
        wxstrTempAddSavePL<<intCounterPer+1;
        strings.Add(wxstrTempAddSavePL);
    }

    wxMultiChoiceDialog dialog(this, wxT("Please choose the periods: "), wxT("Period choice"), strings);
    if(dialog.ShowModal() == wxID_OK)
    {
        wxarrintChosenPeriods=dialog.GetSelections();
    }

    intSavePeriods=wxarrintChosenPeriods.GetCount();

    for(unsigned long intCounterSelPer=0;intCounterSelPer<wxarrintChosenPeriods.GetCount();intCounterSelPer++)
    {
        wxstrTempAddSavePL="";
        wxstrTempAddSavePL<<wxarrintChosenPeriods.Item(intCounterSelPer)+1;
        WxListBoxSaveResStressPeriods->Append(wxstrTempAddSavePL);
    }
}

/*
 * WxButtonAddSaveLayerClick
 */
void gui2Frm::WxButtonAddSaveLayerClick(wxCommandEvent& event)
{
	// insert your code here

	wxArrayString strings;
	wxArrayString stringsRes;
	wxString wxstrTempAddSaveLay;
	wxArrayInt wxarrintChosenLayers;

	for(long intCounterLayer=0;intCounterLayer<intNLAY-1;intCounterLayer++)
	{
        wxstrTempAddSaveLay="";
        wxstrTempAddSaveLay<<intCounterLayer+1;
        strings.Add(wxstrTempAddSaveLay);
    }

    wxMultiChoiceDialog dialog(this, wxT("Please choose the layers: "), wxT("Layer choice"), strings);
    if(dialog.ShowModal() == wxID_OK)
    {
        wxarrintChosenLayers=dialog.GetSelections();
    }

    intSaveLayers=wxarrintChosenLayers.GetCount();

    for(unsigned long intCounterSelLay=0;intCounterSelLay<wxarrintChosenLayers.GetCount();intCounterSelLay++)
    {
        wxstrTempAddSaveLay="";
        wxstrTempAddSaveLay<<wxarrintChosenLayers.Item(intCounterSelLay)+1;
        WxListBoxSaveResLayers->Append(wxstrTempAddSaveLay);
    }
}

/*
 * WxButtonTransferToGISClick
 */
void gui2Frm::WxButtonTransferToGISClick(wxCommandEvent& event)
{
	// insert your code here
	char *transferFile;
	char *transferPath;
    wxString wxTransferFileName;
    transferFile="";
    wxTransferFileName<<pathProjectFilePre<<"/fort.45";
    const char *tempChar2=wxTransferFileName.mbc_str();
    transferFile=(char*)tempChar2;
    const char *tempChar3=pathProjectFileEx.mbc_str();
    transferPath=(char*)tempChar3;
    transferResults transRes;
    transRes.setFile(transferFile, transferPath);
    transRes.getPointsFromFile();
    transRes.setGridParams(intNCOL, intNROW, intSavePeriods, intSaveLayers, dblXMin, dblYMin, dblXDist);
    transRes.analyze_file_content();

}
