//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#include "parameters.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// paramSetting
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(paramSetting,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(paramSetting::OnClose)
	EVT_CHECKBOX(ID_WXCHECKBOXLAYERCONVERTIBLE,paramSetting::WxCheckBoxLayerConvertibleClick)
	EVT_CHECKBOX(ID_WXCHECKBOXLAYERCONFINED,paramSetting::WxCheckBoxLayerConfinedClick)
	EVT_BUTTON(ID_WXBUTTONPARAMSETTING,paramSetting::WxButtonParamSettingClick)
	EVT_BUTTON(ID_WXBUTTONPARAMDISTRIFILECHOOSE,paramSetting::WxButtonParamDistriFileChooseClick)
END_EVENT_TABLE()
////Event Table End

paramSetting::paramSetting(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

paramSetting::~paramSetting()
{
} 

void paramSetting::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxOpenFileDialogParamFile =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.*"));

	WxCheckBoxLayerConvertible = new wxCheckBox(this, ID_WXCHECKBOXLAYERCONVERTIBLE, wxT("Convertible"), wxPoint(146, 157), wxSize(110, 28), 0, wxDefaultValidator, wxT("WxCheckBoxLayerConvertible"));

	WxCheckBoxLayerConfined = new wxCheckBox(this, ID_WXCHECKBOXLAYERCONFINED, wxT("Confined"), wxPoint(21, 160), wxSize(96, 23), 0, wxDefaultValidator, wxT("WxCheckBoxLayerConfined"));

	wxArrayString arrayStringFor_WxListBoxParamSettingInput;
	WxListBoxParamSettingInput = new wxListBox(this, ID_WXLISTBOXPARAMSETTINGINPUT, wxPoint(108, 113), wxSize(189, 28), arrayStringFor_WxListBoxParamSettingInput, wxLB_SINGLE);

	WxButtonParamSetting = new wxButton(this, ID_WXBUTTONPARAMSETTING, wxT("OK"), wxPoint(104, 200), wxSize(86, 22), 0, wxDefaultValidator, wxT("WxButtonParamSetting"));

	WxButtonParamDistriFileChoose = new wxButton(this, ID_WXBUTTONPARAMDISTRIFILECHOOSE, wxT("File..."), wxPoint(10, 115), wxSize(74, 27), 0, wxDefaultValidator, wxT("WxButtonParamDistriFileChoose"));

	WxStaticTextParamConstValue = new wxStaticText(this, ID_WXSTATICTEXTPARAMCONSTVALUE, wxT("Value for layer:"), wxPoint(13, 54), wxDefaultSize, 0, wxT("WxStaticTextParamConstValue"));
	WxStaticTextParamConstValue->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false));

	WxStaticTextParamDistriFile = new wxStaticText(this, ID_WXSTATICTEXTPARAMDISTRIFILE, wxT("Choose parameter distribution file (per layer):"), wxPoint(12, 88), wxDefaultSize, 0, wxT("WxStaticTextParamDistriFile"));
	WxStaticTextParamDistriFile->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false));

	WxEditParamSetConstValue = new wxTextCtrl(this, ID_WXEDITPARAMSETCONSTVALUE, wxT(""), wxPoint(150, 47), wxSize(64, 25), 0, wxDefaultValidator, wxT("WxEditParamSetConstValue"));

	WxCheckBoxParamSetConst = new wxCheckBox(this, ID_WXCHECKBOXPARAMSETCONST, wxT("Setting parameter constant"), wxPoint(18, 16), wxSize(158, 27), 0, wxDefaultValidator, wxT("WxCheckBoxParamSetConst"));

	SetTitle(wxT("Parameter setting"));
	SetIcon(wxNullIcon);
	SetSize(8,8,321,256);
	Center();
	
	////GUI Items Creation End
	intConstantChecked=0;
}

void paramSetting::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxButtonParamDistriFileChooseClick
 */
void paramSetting::WxButtonParamDistriFileChooseClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxstrPathParamFile;
	int intParamFileOpenShow;
	intParamFileOpenShow=WxOpenFileDialogParamFile->ShowModal();
	wxstrPathParamFile=WxOpenFileDialogParamFile->GetPath();
    WxListBoxParamSettingInput->AppendString(wxstrPathParamFile);		
}

/*
 * WxButtonParamSettingClick
 */
void paramSetting::WxButtonParamSettingClick(wxCommandEvent& event)
{
	// insert your code here
	wxString tempStr;
	wxstrParamFilePath=WxListBoxParamSettingInput->GetString(0);
	
	if(WxCheckBoxParamSetConst->GetValue())
	{
        intConstantChecked=1;
        wxstrConstantValue=WxEditParamSetConstValue->GetValue();
    }
    else
    {
        intConstantChecked=-1;
        wxstrConstantValue="";
    }

    Destroy();
}


int paramSetting::getConstantValueChecked()
{
    return intConstantChecked;
}

wxString paramSetting::getConstantValue()
{
    return wxstrConstantValue;
}

wxString paramSetting::getParamFilePath()
{
    return wxstrParamFilePath;
}

void paramSetting::setLayerType(int n)
{
    intLayerTypeVis=n;
    if (intLayerTypeVis>0)
    {
        WxCheckBoxLayerConfined->Show(false);
        WxCheckBoxLayerConvertible->Show(false);
    }
}

/*
 * WxCheckBoxLayerConfinedClick
 */
void paramSetting::WxCheckBoxLayerConfinedClick(wxCommandEvent& event)
{
	// insert your code here
	wxstrLayerType="0";
}

/*
 * WxCheckBoxLayerConvertibleClick
 */
void paramSetting::WxCheckBoxLayerConvertibleClick(wxCommandEvent& event)
{
	// insert your code here
	wxstrLayerType="1";
}

wxString paramSetting::getLayerType()
{
    return wxstrLayerType;
}
void paramSetting::setTextValue(int flag)
{
    if (flag>0)
    {
        WxStaticTextParamConstValue->SetLabel("Value for Layer:");
    }
    
    else
    {
        WxStaticTextParamConstValue->SetLabel("Value for Stress Period:");
    }
}
