//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#include "timesets.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// TimePeriodSettings
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(TimePeriodSettings,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(TimePeriodSettings::OnClose)
	EVT_CHECKBOX(ID_WXCHECKBOXTRANSIENT,TimePeriodSettings::WxCheckBoxTransientClick)
	EVT_CHECKBOX(ID_WXCHECKBOXSTEADYSTATE,TimePeriodSettings::WxCheckBoxSteadyStateClick)
	EVT_BUTTON(ID_WXBUTTONSETSTRESSPERIOD,TimePeriodSettings::WxButtonSetStressPeriodClick)
END_EVENT_TABLE()
////Event Table End

TimePeriodSettings::TimePeriodSettings(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

TimePeriodSettings::~TimePeriodSettings()
{
} 

void TimePeriodSettings::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxCheckBoxTransient = new wxCheckBox(this, ID_WXCHECKBOXTRANSIENT, wxT("Transient"), wxPoint(170, 85), wxSize(95, 25), 0, wxDefaultValidator, wxT("WxCheckBoxTransient"));

	WxCheckBoxSteadyState = new wxCheckBox(this, ID_WXCHECKBOXSTEADYSTATE, wxT("Steady State"), wxPoint(20, 85), wxSize(97, 25), 0, wxDefaultValidator, wxT("WxCheckBoxSteadyState"));

	WxButtonSetStressPeriod = new wxButton(this, ID_WXBUTTONSETSTRESSPERIOD, wxT("Ok"), wxPoint(116, 120), wxSize(82, 23), 0, wxDefaultValidator, wxT("WxButtonSetStressPeriod"));

	WxEditTimeStepLength = new wxTextCtrl(this, ID_WXEDITTIMESTEPLENGTH, wxT("0"), wxPoint(171, 50), wxSize(90, 25), 0, wxDefaultValidator, wxT("WxEditTimeStepLength"));

	WxEditLengthStressPeriod = new wxTextCtrl(this, ID_WXEDITLENGTHSTRESSPERIOD, wxT("0"), wxPoint(171, 10), wxSize(89, 25), 0, wxDefaultValidator, wxT("WxEditLengthStressPeriod"));

	WxStaticTextTimeStepLength = new wxStaticText(this, ID_WXSTATICTEXTTIMESTEPLENGTH, wxT("Time step length:"), wxPoint(10, 50), wxDefaultSize, 0, wxT("WxStaticTextTimeStepLength"));
	WxStaticTextTimeStepLength->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, false));

	WxStaticTextStressPeriodLength = new wxStaticText(this, ID_WXSTATICTEXTSTRESSPERIODLENGTH, wxT("Length of stress period:"), wxPoint(10, 10), wxDefaultSize, 0, wxT("WxStaticTextStressPeriodLength"));
	WxStaticTextStressPeriodLength->SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, false));

	SetTitle(wxT("Stress period settings"));
	SetIcon(wxNullIcon);
	SetSize(8,8,317,188);
	Center();
	
	////GUI Items Creation End
}

void TimePeriodSettings::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxButtonSetStressPeriodClick
 */
void TimePeriodSettings::WxButtonSetStressPeriodClick(wxCommandEvent& event)
{
	// insert your code here
	strNumberPeriods=WxEditLengthStressPeriod->GetValue();
	strTimeStepLength=WxEditTimeStepLength->GetValue();
	if (intModeSet<1)
	{
        wxMessageBox("Please set Steady State or Transient");
    }
	Destroy();
}

wxString TimePeriodSettings::getPeriodLength()
{
    return strNumberPeriods;
}


wxString TimePeriodSettings::getTimeStepLength()
{
    return strTimeStepLength;
}

/*
 * WxCheckBoxSteadyStateClick
 */
void TimePeriodSettings::WxCheckBoxSteadyStateClick(wxCommandEvent& event)
{
	// insert your code here
	strTimeMode<<"Ss";
	intModeSet=1;
}

/*
 * WxCheckBoxTransientClick
 */
void TimePeriodSettings::WxCheckBoxTransientClick(wxCommandEvent& event)
{
	// insert your code here
	strTimeMode<<"Tr";
	intModeSet=2;
}
